/****************************************************************************/
/*                               Beebem                                     */
/*                               ------                                     */
/* This program may be distributed freely within the following restrictions:*/
/*                                                                          */
/* 1) You may not charge for this program or for any part of it.            */
/* 2) This copyright message must be distributed with all copies.           */
/* 3) This program must be distributed complete with source code.  Binary   */
/*    only distribution is not permitted.                                   */
/* 4) The author offers no warrenties, or guarentees etc. - you use it at   */
/*    your own risk.  If it messes something up or destroys your computer   */
/*    thats YOUR problem.                                                   */
/* 5) You may use small sections of code from this program in your own      */
/*    applications - but you must acknowledge its use.  If you plan to use  */
/*    large sections then please ask the author.                            */
/*                                                                          */
/* If you do not agree with any of the above then please do not use this    */
/* program.                                                                 */
/****************************************************************************/
/* Mike Wyatt and NRM's port to win32 - 7/6/97 */
/* Conveted to use DirectX - Mike Wyatt 11/1/98 */
// Econet added Rob O'Donnell. robert@irrelevant.com. 28/12/2004.

#if HAVE_CONFIG_H
#	include <config.h>
#endif

#include <stdio.h>
#include "windows.h"

#include <unistd.h>
//-- #include <initguid.h>
#include "main.h"
#include "beebwin.h"
#include "port.h"
#include "6502core.h"
#include "disc8271.h"
#include "disc1770.h"
#include "sysvia.h"
#include "uservia.h"
#include "video.h"
#include "beebsound.h"
#include "beebmem.h"
#include "beebemrc.h"
#include "atodconv.h"
#include "userkybd.h"
#include "cregistry.h" // David Overton's registry access code.
#include "serial.h"
#include "econet.h"	 // Rob O'Donnell Christmas 2004.
#include "tube.h"

//->#include "ext1770.h"
//++
#include "hardware.h"
#include "user_config.h"
//<-

#include "uefstate.h"
#include "debug.h"
#include "scsi.h"
#include "sasi.h"
#include "z80mem.h"
#include "z80.h"
#include "userkybd.h"
#include "speech.h"
#include "teletext.h"
#include "avi.h"
#include "csw.h"
#include "serialdevices.h"

//+>
//#include "beebem_pages.h"
//<+

// some LED based macros

#define LED_COLOUR_TYPE (LEDByte&4)>>2
#define LED_SHOW_KB (LEDByte&1)
#define LED_SHOW_DISC (LEDByte&2)>>1
#define LED_COL_BASE 64

// Registry access stuff
cRegistry SysReg;
bool RegRes;
int rbs=1;
int *binsize=&rbs;
// End of registry access stuff

void i86_main(void);

FILE *CMDF2;
unsigned char CMA2;


unsigned char HideMenuEnabled;
bool MenuOn;

struct LEDType LEDs;
char DiscLedColour=0; // 0 for red, 1 for green.

//-- AVIWriter *aviWriter = NULL;

// FDC Board extension DLL variables
//-- HMODULE hFDCBoard;

typedef void (*lGetBoardProperties)(struct DriveControlBlock *);
typedef unsigned char (*lSetDriveControl)(unsigned char);
typedef unsigned char (*lGetDriveControl)(unsigned char);

//->
//## see hardware.cpp, include/hardware.h
//##
//-- lGetBoardProperties PGetBoardProperties;
//-- lSetDriveControl PSetDriveControl;
//-- lGetDriveControl PGetDriveControl;
//<-

bool m_PageFlipping=0;

EDCB ExtBoard={0,0,NULL};
bool DiscLoaded[2]={FALSE,FALSE}; // Set to TRUE when a disc image has been loaded.
char CDiscName[2][256]; // Filename of disc current in drive 0 and 1;
char CDiscType[2]; // Current disc types
bool MustEnableSound=FALSE; // Set to true if the directsound must be unmuted after menu loop exit.
char FDCDLL[256];

//->static const char *WindowTitle = "BeebEm - BBC Model B / Master 128 Emulator";
//++
	static const char *WindowTitle = "BeebEm";
//<-
//--static const char *AboutText = "BeebEm - Emulating:\n\nBBC Micro Model B\nBBC Micro Model B + IntegraB\n"
//--								"BBC Micro Model B Plus (128)\nAcorn Master 128\nAcorn 65C02 Second Processor\n"
//--								"Torch Z80 Second Processor\nMaster 512 Second Processor\nAcorn Z80 Second Processor\n\n"
//--								"Version 3.2, April 2006";

/* Configuration file strings */
static const char *CFG_FILE_NAME = "BeebEm.ini";

//->static char *CFG_REG_KEY = "Software\\BeebEm";
//++
	//## Needed by GUI.
char *CFG_REG_KEY = "Software\\BeebEm";
//<-

static char *CFG_VIEW_SECTION = "View";
static char *CFG_VIEW_WIN_SIZE = "WinSize";
static char *CFG_VIEW_SHOW_FPS = "ShowFSP";
static char *CFG_VIEW_DIRECT_ENABLED = "DirectDrawEnabled";
static char *CFG_VIEW_BUFFER_IN_VIDEO = "BufferInVideoRAM";
static char *CFG_VIEW_MONITOR = "Monitor";

static char *CFG_SOUND_SECTION = "Sound";
static char *CFG_SOUND_SAMPLE_RATE = "SampleRate";
static char *CFG_SOUND_VOLUME = "Volume";
static char *CFG_SOUND_ENABLED = "SoundEnabled";
static char *CFG_SOUND_DIRECT_ENABLED = "DirectSoundEnabled";

static char *CFG_OPTIONS_SECTION = "Options";
static char *CFG_OPTIONS_STICKS = "Sticks";
static char *CFG_OPTIONS_KEY_MAPPING = "KeyMapping";
//--static char *CFG_OPTIONS_USER_KEY_MAP = "UserKeyMap";
static char *CFG_OPTIONS_FREEZEINACTIVE = "FreezeWhenInactive";
static char *CFG_OPTIONS_HIDE_CURSOR = "HideCursor";

static char *CFG_SPEED_SECTION = "Speed";
static char *CFG_SPEED_TIMING = "Timing";

static char *CFG_AMX_SECTION = "AMX";
static char *CFG_AMX_ENABLED = "AMXMouseEnabled";
static char *CFG_AMX_LRFORMIDDLE = "AMXMouseLRForMiddle";
static char *CFG_AMX_SIZE = "AMXMouseSize";
static char *CFG_AMX_ADJUST = "AMXMouseAdjust";

static char *CFG_PRINTER_SECTION = "Printer";
static char *CFG_PRINTER_ENABLED = "PrinterEnabled";
static char *CFG_PRINTER_PORT = "PrinterPort";
static char *CFG_PRINTER_FILE = "PrinterFile";

//--static char *CFG_MODEL_SECTION = "Model";
//--static char *CFG_MACHINE_TYPE = "MachineType";

/* Prototypes */
//-- LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
//--
//--// Row,Col - Physical mapping
//--static int transTable1[256][2]={
//--	0,0,	0,0,	0,0,	0,0,   // 0
//--	0,0,	0,0,	0,0,	0,0,   // 4
//--	5,9,	6,0,	0,0,	0,0,   // 8 [BS][TAB]..
//--	0,0,	4,9,	0,0,	0,0,   // 12 .RET..
//--	0,0,	0,1,	0,0,	-2,-2, // 16 .CTRL.BREAK
//--	4,0,	0,0,	0,0,	0,0,   // 20 CAPS...
//--	0,0,	0,0,	0,0,	7,0,   // 24 ...ESC
//--	0,0,	0,0,	0,0,	0,0,   // 28
//--	6,2,	-3,-3,	-3,-4,	6,9,   // 32 SPACE..[End]      2nd is Page Up 3rd is Page Down
//--	0,0,	1,9,	3,9,	7,9,   // 36 .[Left][Up][Right]
//--	2,9,	0,0,	0,0,	0,0,   // 40 [Down]...
//--	0,0,	0,0,	5,9,	0,0,   // 44 ..[DEL].
//--	2,7,	3,0,	3,1,	1,1,   // 48 0123   
//--	1,2,	1,3,	3,4,	2,4,   // 52 4567
//--	1,5,	2,6,	0,0,	0,0,   // 56 89
//--	0,0,	0,0,	0,0,	0,0,   // 60
//--	0,0,	4,1,	6,4,	5,2,   // 64.. ABC
//--	3,2,	2,2,	4,3,	5,3,   // 68  DEFG
//--	5,4,	2,5,	4,5,	4,6,   // 72  HIJK
//--	5,6,	6,5,	5,5,	3,6,   // 76  LMNO
//--	3,7,	1,0,	3,3,	5,1,   // 80  PQRS
//--	2,3,	3,5,	6,3,	2,1,   // 84  TUVW
//--	4,2,	4,4,	6,1,	0,0,   // 88  XYZ
//--	0,0,	6,2,	0,0,	0,0,   // 92  . SPACE ..
//--	0,0,	0,0,	0,0,	0,0,   // 96
//--	0,0,	0,0,	0,0,	0,0,   // 100
//--	0,0,	0,0,	0,0,	-4,0,  // 104 Keypad+
//--	0,0,	-4,1,	0,0,	0,0,   // 108 Keypad-
//--	7,1,	7,2,	7,3,	1,4,   // 112 F1 F2 F3 F4
//--	7,4,	7,5,	1,6,	7,6,   // 116 F5 F6 F7 F8
//--	7,7,	2,0,	2,0,	-2,-2, // 120 F9 F10 F11 F12
//--	0,0,	0,0,	0,0,	0,0,   // 124 
//--	0,0,	0,0,	0,0,	0,0,   // 128
//--	0,0,	0,0,	0,0,	0,0,   // 132
//--	0,0,	0,0,	0,0,	0,0,   // 136
//--	0,0,	0,0,	0,0,	0,0,   // 140
//--	0,0,	0,0,	0,0,	0,0,   // 144
//--	0,0,	0,0,	0,0,	0,0,   // 148
//--	0,0,	0,0,	0,0,	0,0,   // 152
//--	0,0,	0,0,	0,0,	0,0,   // 156
//--	0,0,	0,0,	0,0,	0,0,   // 160
//--	0,0,	0,0,	0,0,	0,0,   // 164
//--	0,0,	0,0,	0,0,	0,0,   // 168
//--	0,0,	0,0,	0,0,	0,0,   // 172
//--	0,0,	0,0,	0,0,	0,0,   // 176
//--	0,0,	0,0,	0,0,	0,0,   // 180
//--	0,0,	0,0,	5,7,	1,8,   // 184  ..;=
//--	6,6,	1,7,	6,7,	6,8,   // 188  ,-./
//--	4,8,	0,0,	0,0,	0,0,   // 192  @ ...
//--	0,0,	0,0,	0,0,	0,0,   // 196
//--	0,0,	0,0,	0,0,	0,0,   // 200
//--	0,0,	0,0,	0,0,	0,0,   // 204
//--	0,0,	0,0,	0,0,	0,0,   // 208
//--	0,0,	0,0,	0,0,	0,0,   // 212
//--	0,0,	0,0,	0,0,	3,8,   // 216 ...[
//--	7,8,	5,8,	2,8,	4,7,   // 220 \]#`
//--	0,0,	0,0,	0,0,	0,0,   // 224
//--	0,0,	0,0,	0,0,	0,0,   // 228
//--	0,0,	0,0,	0,0,	0,0,   // 232
//--	0,0,	0,0,	0,0,	0,0, 
//--	0,0,	0,0,	0,0,	0,0, 
//--	0,0,	0,0,	0,0,	0,0, 
//--	0,0,	0,0,	0,0,	0,0, 
//--	0,0,	0,0,	0,0,	0,0 
//--};
//--
//--/* Currently selected translation table */
//--static int (*transTable)[2] = transTable1;
long WindowPos[4];

extern int kbd_load_mapping(char *kbd_filename);

/****************************************************************************/
BeebWin::BeebWin()
{   
}

void BeebWin::SetSoundEnabled(int enabled)
{
	if (enabled != 0)
	{
		SoundInit();
		SoundDefault = 1;
		SoundEnabled = 1;
	}
	else
	{
		SoundReset();
		SoundDefault=0;
		SoundEnabled = 0;
	}
}

/****************************************************************************/
void BeebWin::Initialise()
{   
//+>
	//SetWindowText(m_hWnd, WindowTitle);
//<+

	m_DXInit = FALSE;
	m_LastStartY = 0;
	m_LastNLines = 256;
	m_LastTickCount = 0;
	m_KeyMapAS = 0;
	m_KeyMapFunc = 0;
	m_ShiftPressed = 0;
	m_ShiftBooted = false;
	for (int k = 0; k < 256; ++k)
	{
		m_vkeyPressed[k][0][0] = -1;
		m_vkeyPressed[k][1][0] = -1;
		m_vkeyPressed[k][0][1] = -1;
		m_vkeyPressed[k][1][1] = -1;
	}

	
	LoadPreferences();

	//TouchScreenOpen();

	// Parse command after reading prefs - may override settings
	
	ParseCommandLine();

	IgnoreIllegalInstructions = 1;

//--	aviWriter = NULL;

	m_WriteProtectDisc[0] = !IsDiscWritable(0);
	m_WriteProtectDisc[1] = !IsDiscWritable(1);
	UEFTapeName[0]=0;

//->	m_hBitmap = m_hOldObj = m_hDCBitmap = NULL;
//++
	m_hBitmap = m_hOldObj = m_hDCBitmap = 0;
//<-
	m_screen = m_screen_blur = NULL;
	m_ScreenRefreshCount = 0;
	m_RelativeSpeed = 1;
	m_FramesPerSecond = 50;
	//strcpy(m_szTitle, WindowTitle);

//->	m_AviDC = NULL;
//--	m_AviDIB = NULL;
//++
	m_AviDC = m_AviDIB = 0;
//<-

	for(int i=0;i<256;i++)
		cols[i] = i;

	InitClass();
	CreateBeebWindow(); 
	CreateBitmap();

	InitMenu();

	/* Initialise printer */
	if (PrinterEnabled)
		PrinterEnable(m_PrinterDevice);
	else
		PrinterDisable();

	/* Joysticks can only be initialised after the window is created (needs hwnd) */
	if (m_MenuIdSticks == IDM_JOYSTICK)
		InitJoystick();

	
	getcwd(m_AppPath, sizeof(m_AppPath));
	
	m_frozen = FALSE;

	/* RomPath is defined in beebmem.cpp and is 512 bytes long */

	strcpy(RomPath, m_AppPath);
	strcat(RomPath, "/roms");

	UpdateModelType();
	UpdateSFXMenu();
	UpdateLEDMenu(m_hMenu);
	MenuOn=TRUE;

	LoadFDC(NULL, true);

	SetTapeSpeedMenu();
	UpdateOptiMenu();

	SaveWindowPos();

	SoundReset();
	if (SoundDefault) SoundInit();

	if (SpeechDefault)
		tms5220_start();

	ResetBeebSystem(MachineType,TubeEnabled,1); 

	// Boot file if passed on command line
	HandleCommandLineFile();
}

/****************************************************************************/
BeebWin::~BeebWin()
{   
	if (SoundEnabled)
		SoundReset();
}



//+>
//## From beebwin.h

void BeebWin::doHorizLine(unsigned long Col, int y, int sx, int width) {
//->            if (TeletextEnabled) y/=TeletextStyle;
//--            int d = (y*800)+sx+ScreenAdjust+(TeletextEnabled?36:0);
//--            if ((d+width)>(500*800)) return;
//--            if (d<0) return;
//--            memset(m_screen+d, Col, width);
//++
                int d, teletext_inc = 72;
                unsigned char *p = NULL;

                if (TeletextEnabled)
                        y/=TeletextStyle;


                switch (fullscreen
                 ?cfg_Fullscreen_Resolution:cfg_Windowed_Resolution) {
                        case RESOLUTION_640X512:
                                break;
                        case RESOLUTION_640X480_S:
                                break;
                        case RESOLUTION_640X480_V:
                                break;
                        case RESOLUTION_320X240_S:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
				teletext_inc>>=1;
                                break;
                        case RESOLUTION_320X240_V:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
				teletext_inc>>=1;
                                break;
                        case RESOLUTION_320X256:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
				teletext_inc>>=1;
                                break;
                        default:
                                break;
                }

                if (y >= 600){
                        //pERROR(dL"[0332]: y >= 600 (is %d)", dR, (int) y);
                        return;
                }

//->            d = sx+(TeletextEnabled?36:0);
//++
                d = sx+(TeletextEnabled?teletext_inc:0);
//<-

                if ( d < 0) { return; } // qERROR("[0332]: d < 0"); return; }

                p = (unsigned char*) GetSDLScreenLinePtr(y-2);
                if (p == NULL){
                        qERROR("GetSDLScreenLinePtr returned NULL!");
                        exit(1);
                }else{
                        memset(p + d, Col, width);
                }
//<-
        };

void BeebWin::doInvHorizLine(unsigned long Col, int y, int sx, int width) {
//->            if (TeletextEnabled) y/=TeletextStyle;
//--            int d = (y*800)+sx+ScreenAdjust+(TeletextEnabled?36:0);
//--            char *vaddr;
//--            if ((d+width)>(500*800)) return;
//--            if (d<0) return;
//--            vaddr=m_screen+d;
//--            for (int n=0;n<width;n++) *(vaddr+n)^=Col;
//++
                if (TeletextEnabled) y/=TeletextStyle;

                char *vaddr;
                int d, n, teletext_inc=72;



                switch (fullscreen
                 ?cfg_Fullscreen_Resolution:cfg_Windowed_Resolution) {
                        case RESOLUTION_640X512:
                                break;
                        case RESOLUTION_640X480_S:
                                break;
                        case RESOLUTION_640X480_V:
                                break;
                        case RESOLUTION_320X240_S:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
				teletext_inc>>=1;
                                break;
                        case RESOLUTION_320X240_V:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
				teletext_inc>>=1;
                                break;
                        case RESOLUTION_320X256:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
				teletext_inc>>=1;
                                break;
                        default:
                                break;
                }





//->            d = sx + (TeletextEnabled?36:0);
//++
                d = sx + (TeletextEnabled?teletext_inc:0);
//<-
                if ( y >= 600) {
                        //pERROR(dL"[0333]: y >= 600 (is %d)", dR, (int) y);
                        return;
                }

                if ( d < 0) { return; } //qERROR("[0333]: d < 0"); return; }

                vaddr = (char*) GetSDLScreenLinePtr(y);
                if (vaddr == NULL) {
                        qERROR("GetSDLScreenLinePtr returned NULL!");
                        exit(1);
                } else {
                        vaddr += d;
                        for (n = 0; n < width; n++) *(vaddr + n) ^= Col;
                }
//<-
        };

void BeebWin::doUHorizLine(unsigned long Col, int y, int sx, int width) {
//->            if (TeletextEnabled) y/=TeletextStyle;
//--            if (y>500) return;
//--            memset(m_screen+ (y* 800) + sx, Col, width);
//++
                unsigned char *p = NULL;

                if (TeletextEnabled) y/=TeletextStyle;

                if ( y>=600) {
                        //pERROR(dL"[0334]: y >= 600 (is %d)", dR, (int) y);
                        return;
                }



                switch (fullscreen
                 ?cfg_Fullscreen_Resolution:cfg_Windowed_Resolution) {
                        case RESOLUTION_640X512:
                                break;
                        case RESOLUTION_640X480_S:
                                break;
                        case RESOLUTION_640X480_V:
                                break;
                        case RESOLUTION_320X240_S:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
                                break;
                        case RESOLUTION_320X240_V:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
                                break;
                        case RESOLUTION_320X256:
				sx>>=1; if(TeletextEnabled) y>>=1; width>>=1;
                                break;
                        default:
                                break;
                }




                p = (unsigned char*) GetSDLScreenLinePtr(y);
                if (p == NULL){
                        qERROR("GetSDLScreenLinePtr returned NULL!");
                        exit(1);
                }else{
                        memset(p + sx, Col, width);
                }
//<-
        };
//<+

void BeebWin::SaveSettingsForLoadedDisc(void)
{
	if (strlen(mainWin->m_save_name) > 0)
	{
		beeb_save_settings();
	}
}

/****************************************************************************/
void BeebWin::SaveWindowPos(void)
{
//--	RECT r;
//--	GetWindowRect(GETHWND,&r);
//--	*binsize=sizeof(r);
//--	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"WindowPos2",&r,binsize);
}
/****************************************************************************/
void BeebWin::ResetBeebSystem(unsigned char NewModelType,unsigned char TubeStatus,unsigned char LoadRoms) 
{
	SwitchOnCycles=0; // Reset delay
	SoundChipReset();
	SwitchOnSound();
	EnableTube=TubeStatus;
	MachineType=NewModelType;
	BeebMemInit(LoadRoms,m_ShiftBooted);
	Init6502core();
	if (EnableTube) Init65C02core();
	if (Tube186Enabled) i86_main();
    Enable_Z80 = 0;
    if (TorchTube || AcornZ80)
    {
       R1Status = 0;
       ResetTube();
       init_z80();
       Enable_Z80 = 1;
    }
    SysVIAReset();
	UserVIAReset();
	VideoInit();
	Disc8271_reset();
#ifdef WITH_ECONET
	if (EconetEnabled) EconetReset();	//Rob:
#endif
	Reset1770();
	AtoDReset();
	SetRomMenu();
	FreeDiscImage(0);
	// Keep the disc images loaded
	FreeDiscImage(1);
	Close1770Disc(0);
	Close1770Disc(1);
	if (HardDriveEnabled) SCSIReset();
	if (HardDriveEnabled) SASIReset();
	TeleTextInit();
	if (MachineType==3) InvertTR00=FALSE;
	if (MachineType!=3) {
		LoadFDC(NULL, false);
	}
	if ((MachineType!=3) && (NativeFDC)) {
		// 8271 disc
		if ((DiscLoaded[0]) && (CDiscType[0]==0)) LoadSimpleDiscImage(CDiscName[0],0,0,80);
		if ((DiscLoaded[0]) && (CDiscType[0]==1)) LoadSimpleDSDiscImage(CDiscName[0],0,80);
		if ((DiscLoaded[1]) && (CDiscType[1]==0)) LoadSimpleDiscImage(CDiscName[1],1,0,80);
		if ((DiscLoaded[1]) && (CDiscType[1]==1)) LoadSimpleDSDiscImage(CDiscName[1],1,80);
	}
	if (((MachineType!=3) && (!NativeFDC)) || (MachineType==3)) {
		// 1770 Disc
		if (DiscLoaded[0]) Load1770DiscImage(CDiscName[0],0,CDiscType[0],m_hMenu);
		if (DiscLoaded[1]) Load1770DiscImage(CDiscName[1],1,CDiscType[1],m_hMenu);
	}
}
/****************************************************************************/
void BeebWin::CreateBitmap()
{
	SetBeebEmEmulatorCoresPalette(cols, palette_type);
}

/****************************************************************************/
BOOL BeebWin::InitClass(void)
{
	return(0);
}

/****************************************************************************/
void BeebWin::CreateBeebWindow(void)
{
}

void BeebWin::ShowMenu(bool on) {
	MenuOn=on;
}

void BeebWin::TrackPopupMenu(int x, int y) {
}

/****************************************************************************/
void BeebWin::InitMenu(void)
{
	char menu_string[256];
	HMENU hMenu = m_hMenu;

	CheckMenuItem(hMenu, m_MenuIdAviResolution, MF_CHECKED);
	CheckMenuItem(hMenu, m_MenuIdAviSkip, MF_CHECKED);
	CheckMenuItem(hMenu, IDM_SPEEDANDFPS, m_ShowSpeedAndFPS ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, m_MenuIdWinSize, MF_CHECKED);
	CheckMenuItem(hMenu, IDM_FULLSCREEN, m_isFullScreen ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_DD32ONOFF, m_isDD32 ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_SOUNDONOFF, SoundEnabled ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, m_MenuIdSampleRate, MF_CHECKED);
	CheckMenuItem(hMenu, m_MenuIdVolume, MF_CHECKED);
	CheckMenuItem(hMenu, m_MenuIdTiming, MF_CHECKED);
	if (m_MenuIdSticks != 0)
		CheckMenuItem(hMenu, m_MenuIdSticks, MF_CHECKED);
	CheckMenuItem(hMenu, IDM_FREEZEINACTIVE, m_FreezeWhenInactive ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_HIDECURSOR, m_HideCursor ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_IGNOREILLEGALOPS,
					IgnoreIllegalInstructions ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, m_MenuIdKeyMapping, MF_CHECKED);
	CheckMenuItem(hMenu, IDM_MAPAS, m_KeyMapAS ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_MAPFUNCS, m_KeyMapFunc ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_WPDISC0, m_WriteProtectDisc[0] ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_WPDISC1, m_WriteProtectDisc[1] ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_AMXONOFF, AMXMouseEnabled ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_AMX_LRFORMIDDLE, AMXLRForMiddle ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, m_MenuIdAMXSize, MF_CHECKED);
	if (m_MenuIdAMXAdjust != 0)
		CheckMenuItem(hMenu, m_MenuIdAMXAdjust, MF_CHECKED);
	CheckMenuItem(hMenu, IDM_PRINTERONOFF, PrinterEnabled ? MF_CHECKED : MF_UNCHECKED);
	strcpy(menu_string, "File: ");
	strcat(menu_string, m_PrinterFileName);
	ModifyMenu(hMenu, IDM_PRINTER_FILE, MF_BYCOMMAND, IDM_PRINTER_FILE, menu_string);
	CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_CHECKED);
	CheckMenuItem(hMenu, IDM_DDRAWONOFF, m_DirectDrawEnabled ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_DDINVIDEORAM, m_DDS2InVideoRAM ? MF_CHECKED : MF_UNCHECKED);

	CheckMenuItem(hMenu, m_DDFullScreenMode, MF_CHECKED);

	CheckMenuItem(hMenu, ID_SERIAL, SerialPortEnabled ? MF_CHECKED:MF_UNCHECKED);
	//CheckMenuItem(hMenu, ID_TOUCHSCREEN, TouchScreenEnabled ? MF_CHECKED:MF_UNCHECKED);

	CheckMenuItem(hMenu, ID_COM1, (SerialPort==1)? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_COM2, (SerialPort==2)? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_COM3, (SerialPort==3)? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_COM4, (SerialPort==4)? MF_CHECKED:MF_UNCHECKED);

	CheckMenuItem(hMenu, ID_HIDEMENU, HideMenuEnabled ? MF_CHECKED:MF_UNCHECKED);

	CheckMenuItem(m_hMenu,ID_TAPESOUND,(TapeSoundEnabled)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,IDM_SOUNDCHIP,(SoundChipEnabled)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_PSAMPLES,(PartSamples)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu, IDM_EXPVOLUME, SoundExponentialVolume ? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);

	CheckMenuItem(m_hMenu,ID_UNLOCKTAPE,(UnlockTape)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,m_MotionBlur,MF_CHECKED);
#ifdef WITH_ECONET
	CheckMenuItem(hMenu, ID_ECONET, EconetEnabled ? MF_CHECKED:MF_UNCHECKED);	//Rob
#endif
	CheckMenuItem(hMenu, ID_TELETEXT, TeleTextAdapterEnabled ? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_HARDDRIVE, HardDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, IDM_SPEECH, SpeechDefault ? MF_CHECKED:MF_UNCHECKED);

//+>
	// BeebEm SDL Additional Options:

	CheckMenuItem(hMenu, OPT_EMULATECRTGRAPHICS, cfg_EmulateCrtGraphics ? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, OPT_EMUALTECRTTELETEXT, cfg_EmulateCrtTeletext ? MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, OPT_WANTLOWLATENCYSOUND, cfg_WantLowLatencySound ? MF_CHECKED:MF_UNCHECKED);

// Timing:
	switch (cfg_WaitType){

	case OPT_SLEEP_OS:
		CheckMenuItem(hMenu,OPT_SLEEP_OS, MF_CHECKED);
		break;
	case OPT_SLEEP_F1:
		CheckMenuItem(hMenu,OPT_SLEEP_F1, MF_CHECKED);
		break;
	case OPT_SLEEP_F2:
		CheckMenuItem(hMenu,OPT_SLEEP_F2, MF_CHECKED);
		break;
	case OPT_SLEEP_F3:
		CheckMenuItem(hMenu,OPT_SLEEP_F3, MF_CHECKED);
		break;
	case OPT_SLEEP_BW:
		CheckMenuItem(hMenu,OPT_SLEEP_BW, MF_CHECKED);
		break;
	}

	// Update FDC buttons.
	//Update_FDC_Buttons();


	// Update Resolution buttons.
	//Update_Resolution_Buttons();
//<+

	UpdateMonitorMenu();

	/* Initialise the ROM Menu. */
	SetRomMenu();

	SetSoundMenu();
}

void BeebWin::UpdateMonitorMenu() {
	HMENU hMenu = m_hMenu;
	CheckMenuItem(hMenu, ID_MONITOR_RGB, (palette_type == RGB) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_MONITOR_BW , (palette_type == BW) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_MONITOR_GREEN , (palette_type == GREEN) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_MONITOR_AMBER , (palette_type == AMBER) ? MF_CHECKED : MF_UNCHECKED);
}

void BeebWin::UpdateModelType() {
	HMENU hMenu= m_hMenu;
	CheckMenuItem(hMenu, ID_MODELB, (MachineType == 0) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_MODELBINT, (MachineType == 1) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_MODELBP, (MachineType == 2) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_MASTER128, (MachineType == 3) ? MF_CHECKED : MF_UNCHECKED);
}

void BeebWin::UpdateSFXMenu() {
	HMENU hMenu = m_hMenu;
	CheckMenuItem(hMenu,ID_SFX_RELAY,RelaySoundEnabled?MF_CHECKED:MF_UNCHECKED);
}

/****************************************************************************/
void BeebWin::InitDirectX(void)
{
}

/****************************************************************************/
HRESULT BeebWin::InitSurfaces(void)
{
	return(0);
}

/****************************************************************************/
void BeebWin::ResetSurfaces(void)
{
}

/****************************************************************************/
void BeebWin::SetRomMenu(void)
{
	HMENU hMenu = m_hMenu;

	// Set the ROM Titles in the ROM/RAM menu.
	CHAR Title[19];
	
	int	 i;

	for( i=0; i<16; i++ )
	{
//->		Title[0] = '&';
//--		_itoa( i, &Title[1], 16 );
//--
//--		Title[2] = ' ';
//--
//--		// Get the Rom Title.
//--		ReadRomTitle( i, &Title[3], sizeof( Title )-4);
//--	
//--		if ( Title[3]== '\0' )
//--			strcpy( &Title[3], "Empty" );
//++
		sprintf(Title, "%1X ", i); 
		ReadRomTitle( i, &Title[2], sizeof( Title )-3);
		if ( Title[2]== '\0' ) strcpy( &Title[2], "Empty" );
//<-

		ModifyMenu( hMenu,	// handle of menu 
					IDM_ALLOWWRITES_ROM0 + i,
					MF_BYCOMMAND,	// menu item to modify
				//	MF_STRING,	// menu item flags 
					IDM_ALLOWWRITES_ROM0 + i,	// menu item identifier or pop-up menu handle
					Title		// menu item content 
					);

		/* LRW Now uncheck the Roms which are NOT writable, that have already been loaded. */
		CheckMenuItem(hMenu, IDM_ALLOWWRITES_ROM0 + i, RomWritable[i] ? MF_CHECKED : MF_UNCHECKED );
	}
}

/****************************************************************************/
void BeebWin::GetRomMenu(void)
{
	HMENU hMenu = m_hMenu;

	for (int i=0; i<16; ++i)
	  /* LRW Now uncheck the Roms as NOT writable, that have already been loaded. */
	  RomWritable[i] = ( GetMenuState(hMenu, IDM_ALLOWWRITES_ROM0 + i, MF_BYCOMMAND ) & MF_CHECKED );
}

/****************************************************************************/
void BeebWin::InitJoystick(void)
{
}

/****************************************************************************/
void BeebWin::ScaleJoystick(unsigned int x, unsigned int y)
{
//--	/* Scale and reverse the readings */
//--	JoystickX = (int)((double)(m_JoystickCaps.wXmax - x) * 65535.0 /
//--						(double)(m_JoystickCaps.wXmax - m_JoystickCaps.wXmin));
//--	JoystickY = (int)((double)(m_JoystickCaps.wYmax - y) * 65535.0 /
//--						(double)(m_JoystickCaps.wYmax - m_JoystickCaps.wYmin));
}

/****************************************************************************/
void BeebWin::ResetJoystick(void)
{
//--	joyReleaseCapture(JOYSTICKID1);
	//AtoDReset();
}

/****************************************************************************/
void BeebWin::SetMousestickButton(int button)
{
	if (m_MenuIdSticks == IDM_MOUSESTICK)
		JoystickButton = button;
}

/****************************************************************************/
void BeebWin::ScaleMousestick(unsigned int x, unsigned int y)
{
static int lastx = 32768;
static int lasty = 32768;
int dx, dy;

	if (m_MenuIdSticks == IDM_AMOUSESTICK)				// Analogue mouse stick
	{
		JoystickX = (m_XWinSize - x) * 65535 / m_XWinSize;
		JoystickY = (m_YWinSize - y) * 65535 / m_YWinSize;
	} else if (m_MenuIdSticks == IDM_DMOUSESTICK)		// Digital mouse stick
	{
		dx = x - lastx;
		dy = y - lasty;
		
		if (dx > 4) JoystickX = 0;
		if (dx < -4) JoystickX = 65535;

		if (dy > 4) JoystickY = 0;
		if (dy < -4) JoystickY = 65535;

		lastx = x;
		lasty = y;
	}

//--	if (m_HideCursor)
//--		SetCursor(NULL);
}

/****************************************************************************/
void BeebWin::SetAMXPosition(unsigned int x, unsigned int y)
{
	if (AMXMouseEnabled)
	{
		// Scale the window coords to the beeb screen coords
		AMXTargetX = x * m_AMXXSize * (100 + m_AMXAdjust) / 100 / m_XWinSize;
		AMXTargetY = y * m_AMXYSize * (100 + m_AMXAdjust) / 100 / m_YWinSize;
		AMXMouseMovement();
	}

	//printf("AMX: %d %d %d\n", AMXTargetX, AMXTargetY, AMXButtons);
}


/****************************************************************************/
int BeebWin::TranslateKey(int vkey, int keyUp, int &row, int &col)
{
	return(row);
}

/****************************************************************************/
int BeebWin::StartOfFrame(void)
{
	int FrameNum = 1;

	if (UpdateTiming())
		FrameNum = 0;

	return FrameNum;
}

void BeebWin::doLED(int sx,bool on) {
	int tsy; char colbase;
	colbase=(DiscLedColour*2)+LED_COL_BASE; // colour will be 0 for red, 1 for green.
	if (sx<100) colbase=LED_COL_BASE; // Red leds for keyboard always

	if (TeletextEnabled)
//->		tsy=496;
//++
		tsy=496-1;
//<-
	else
//->		tsy=m_LastStartY+m_LastNLines-2;
//++
		tsy=256-2+32-6-1;
//<-

	doUHorizLine(mainWin->cols[((on)?1:0)+colbase],tsy,sx,8);
//--	doUHorizLine(mainWin->cols[((on)?1:0)+colbase],tsy,sx,8);
};

/****************************************************************************/
void BeebWin::updateLines(HDC hDC, int starty, int nlines)
{
	int i, TTLines=0;


// [TODO] Might want to make m_screen point to the SDL_Surface.
//	if (m_screen == NULL)
//		return;

	if (starty == 0 && nlines == 0){
		starty = m_LastStartY;
		nlines = m_LastNLines;
	}else{
		m_LastStartY = starty;
		m_LastNLines = nlines;
	}

	++m_ScreenRefreshCount;
	TTLines=500/TeletextStyle;
	
	// [TODO] Use m_isFullScreen instead.
#ifdef WITH_FS_FPS
	if (m_ShowSpeedAndFPS && fullscreen){
		char fps[50];
		sprintf(fps, "%2.2f %2d", m_RelativeSpeed, (int)m_FramesPerSecond);
		RenderFullscreenFPS(fps, TeletextEnabled ? 0: 32);
	}
#endif

	//XXX ZZZ new thing
	if (mainWin->m_skip_cur_frame <= 0) 
	{ 
		mainWin->m_skip_cur_frame = mainWin->m_skip_max_frame;
		
		for(i = 0; i < nlines; i++)
		{
			if (i+starty < 600) 
			{
				RenderLine(i+starty, (int) TeletextEnabled, ScreenAdjust);
			}
		}
		//do_flip = true;
		/*mainWin->m_render_blank_line--;
		if (mainWin->m_render_blank_line < 0) 
		{
			mainWin->m_render_blank_line = mainWin->m_render_max_blank_line;
		}*/
		
	} 
	else if (mainWin->m_skip_max_frame) 
	{
		mainWin->m_skip_cur_frame--;
	}
/*XXX ZZZ critical
	for(i = 0; i < nlines; i++){
		if (i+starty < 600)
			RenderLine(i+starty, (int) TeletextEnabled, ScreenAdjust);

	}*/
//<+

}

/****************************************************************************/
void BeebWin::ResetTiming(void)
{

	m_LastTickCount = GetTickCount();
	m_LastStatsTickCount = m_LastTickCount;
	m_LastTotalCycles = TotalCycles;
	m_LastStatsTotalCycles = TotalCycles;
	m_TickBase = m_LastTickCount;
	m_CycleBase = TotalCycles;
	m_MinFrameCount = 0;
	m_LastFPSCount = m_LastTickCount;
	m_ScreenRefreshCount = 0;
}

/****************************************************************************/
BOOL BeebWin::UpdateTiming(void)
{
	DWORD TickCount;
	DWORD Ticks;
	DWORD SpareTicks;
	int Cycles;
	int CyclesPerSec;
	bool UpdateScreen = FALSE;

	TickCount = GetTickCount();

	/* Don't do anything if this is the first call or there has
	   been a long pause due to menu commands, or when something
	   wraps. */
	if (m_LastTickCount == 0 ||
		TickCount < m_LastTickCount ||
		(TickCount - m_LastTickCount) > 1000 ||
		TotalCycles < m_LastTotalCycles)
	{
		ResetTiming();
		return TRUE;
	}

	/* Update stats every second */
	if (TickCount >= m_LastStatsTickCount + 1000)
	{
		m_FramesPerSecond = m_ScreenRefreshCount;
		m_ScreenRefreshCount = 0;
		m_RelativeSpeed = ((TotalCycles - m_LastStatsTotalCycles) / 2000.0) /
								(TickCount - m_LastStatsTickCount);
		m_LastStatsTotalCycles = TotalCycles;
		m_LastStatsTickCount += 1000;
		DisplayTiming();
	}

	// Now we work out if BeebEm is running too fast or not
	if (m_RealTimeTarget > 0.0)
	{
		Ticks = TickCount - m_TickBase;
		Cycles = (int)((double)(TotalCycles - m_CycleBase) / m_RealTimeTarget);

		if (Ticks <= (DWORD)(Cycles / 2000))
		{
			// Need to slow down, show frame (max 50fps though) 
			// and sleep a bit
			if (TickCount >= m_LastFPSCount + 20)
			{
				UpdateScreen = TRUE;
				m_LastFPSCount += 20;
			}
			else
			{
				UpdateScreen = FALSE;
			}

			SpareTicks = (DWORD)(Cycles / 2000) - Ticks;

			if (SpareTicks>0) 
				Sleep(SpareTicks);

			m_MinFrameCount = 0;
		}
		else
		{
			// Need to speed up, skip a frame
			UpdateScreen = FALSE;

			// Make sure we show at least one in 100 frames
			++m_MinFrameCount;
			if (m_MinFrameCount >= 100)
			{
				UpdateScreen = TRUE;
				m_MinFrameCount = 0;
			}
		}

		/* Move counter bases forward */
		CyclesPerSec = (int) (2000000.0 * m_RealTimeTarget);

		while ((TickCount - m_TickBase) > 1000 && (TotalCycles - m_CycleBase) > CyclesPerSec)
		{
			m_TickBase += 1000;
			m_CycleBase += CyclesPerSec;
		}
	}
	else
	{
		/* Fast as possible with a certain frame rate */
		if (TickCount >= m_LastFPSCount + (1000 / m_FPSTarget))
		{
			UpdateScreen = TRUE;
			m_LastFPSCount += 1000 / m_FPSTarget;
		}
		else
		{
			UpdateScreen = FALSE;
		}
	}

	m_LastTickCount = TickCount;
	m_LastTotalCycles = TotalCycles;

	return UpdateScreen;
}

/****************************************************************************/
void BeebWin::DisplayTiming(void)
{
	/*if (m_ShowSpeedAndFPS)
	{
		
	}*/
	//if (SDL_JoystickGetButton(joy, GP2X_BUTTON_
	//if (m_ShowSpeedAndFPS && (!m_DirectDrawEnabled || !m_isFullScreen))
	//{
	//	sprintf(m_szTitle, "%s  Speed: %2.2f  fps: %2d",
	//			WindowTitle, m_RelativeSpeed, (int)m_FramesPerSecond);
	//	SetWindowText(m_hWnd, m_szTitle);
	//}
}

/****************************************************************************/
void BeebWin::TranslateWindowSize(void)
{
//--	if (m_isFullScreen)
//--	{
//--		if (m_DirectDrawEnabled)
//--		{
//--			switch (m_DDFullScreenMode)
//--			{
//--			case ID_VIEW_DD_640X480:
//--			  m_XWinSize = 640;
//--			  m_YWinSize = 480;
//--			  break;
//--			case ID_VIEW_DD_1024X768:
//--			  m_XWinSize = 1024;
//--			  m_YWinSize = 768;
//--			  break;
//--			case ID_VIEW_DD_1280X1024:
//--			  m_XWinSize = 1280;
//--			  m_YWinSize = 1024;
//--			  break;
//--			}
//--		}
//--		else
//--		{
//--			RECT scrrect;
//--			SystemParametersInfo(SPI_GETWORKAREA, 0, (PVOID)&scrrect, 0);
//--			m_XWinSize = scrrect.right - scrrect.left - GetSystemMetrics(SM_CXFIXEDFRAME) * 2;
//--			m_YWinSize = scrrect.bottom - scrrect.top - GetSystemMetrics(SM_CYFIXEDFRAME) * 2
//--					- GetSystemMetrics(SM_CYMENUSIZE) - GetSystemMetrics(SM_CYCAPTION);
//--		}
//--	}
//--	else
//--	{
//--	  switch (m_MenuIdWinSize)
//--	  {
//--	  case IDM_160X128:
//--		  m_XWinSize = 160;
//--		  m_YWinSize = 128;
//--		  break;
//--
//--	  case IDM_240X192:
//--		  m_XWinSize = 240;
//--		  m_YWinSize = 192;
//--		  break;
//--
//--	  case IDM_640X256:
//--		  m_XWinSize = 640;
//--		  m_YWinSize = 256;
//--		  break;
//--
//--	  case IDM_320X256:
//--		  m_XWinSize = 320;
//--		  m_YWinSize = 256;
//--		  break;
//--
//--	  default:
//--	  case IDM_640X512:
		  m_XWinSize = 640;
		  m_YWinSize = 512;
//--		  break;
//--
//--	  case IDM_800X600:
//--		  m_XWinSize = 800;
//--		  m_YWinSize = 600;
//--		  break;
//--
//--	  case IDM_1024X768:
//--		  m_XWinSize = 1024;
//--		  m_YWinSize = 768;
//--		  break;
//--
//--	  case IDM_1024X512:
//--		  m_XWinSize = 1024;
//--		  m_YWinSize = 512;
//--		  break;
//--	  }
//--	}
}

/****************************************************************************/
void BeebWin::TranslateSampleRate(void)
{
	switch (m_MenuIdSampleRate)
	{
	case IDM_44100KHZ:
		SoundSampleRate = 44100;
		break;

	default:
	case IDM_22050KHZ:
		SoundSampleRate = 22050;
		break;

	case IDM_11025KHZ:
		SoundSampleRate = 11025;
		break;
	}
}

/****************************************************************************/
void BeebWin::TranslateVolume(void)
{
	switch (m_MenuIdVolume)
	{
	case IDM_FULLVOLUME:
		SoundVolume = 1;
		break;

	case IDM_HIGHVOLUME:
		SoundVolume = 2;
		break;

	default:
	case IDM_MEDIUMVOLUME:
		SoundVolume = 3;
		break;

	case IDM_LOWVOLUME:
		SoundVolume = 4;
		break;
	}
}

/****************************************************************************/
void BeebWin::TranslateTiming(void)
{
	m_FPSTarget = 0;
	m_RealTimeTarget = 1.0;

	if (m_MenuIdTiming == IDM_3QSPEED)
		m_MenuIdTiming = IDM_FIXEDSPEED0_75;
	if (m_MenuIdTiming == IDM_HALFSPEED)
		m_MenuIdTiming = IDM_FIXEDSPEED0_5;

	switch (m_MenuIdTiming)
	{
	default:
	case IDM_REALTIME:
		m_RealTimeTarget = 1.0;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED100:
		m_RealTimeTarget = 100.0;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED50:
		m_RealTimeTarget = 50.0;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED10:
		m_RealTimeTarget = 10.0;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED5:
		m_RealTimeTarget = 5.0;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED2:
		m_RealTimeTarget = 2.0;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED1_5:
		m_RealTimeTarget = 1.5;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED1_25:
		m_RealTimeTarget = 1.25;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED1_1:
		m_RealTimeTarget = 1.1;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED0_9:
		m_RealTimeTarget = 0.9;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED0_5:
		m_RealTimeTarget = 0.5;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED0_75:
		m_RealTimeTarget = 0.75;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED0_25:
		m_RealTimeTarget = 0.25;
		m_FPSTarget = 0;
		break;

	case IDM_FIXEDSPEED0_1:
		m_RealTimeTarget = 0.1;
		m_FPSTarget = 0;
		break;

	case IDM_50FPS:
		m_FPSTarget = 50;
		m_RealTimeTarget = 0;
		break;

	case IDM_25FPS:
		m_FPSTarget = 25;
		m_RealTimeTarget = 0;
		break;

	case IDM_10FPS:
		m_FPSTarget = 10;
		m_RealTimeTarget = 0;
		break;

	case IDM_5FPS:
		m_FPSTarget = 5;
		m_RealTimeTarget = 0;
		break;

	case IDM_1FPS:
		m_FPSTarget = 1;
		m_RealTimeTarget = 0;
		break;
	}

	ResetTiming();
}

void BeebWin::AdjustSpeed(bool up)
{
	static int speeds[] = {
				IDM_FIXEDSPEED100,
				IDM_FIXEDSPEED50,
				IDM_FIXEDSPEED10,
				IDM_FIXEDSPEED5,
				IDM_FIXEDSPEED2,
				IDM_FIXEDSPEED1_5,
				IDM_FIXEDSPEED1_25,
				IDM_FIXEDSPEED1_1,
				IDM_REALTIME,
				IDM_FIXEDSPEED0_9,
				IDM_FIXEDSPEED0_75,
				IDM_FIXEDSPEED0_5,
				IDM_FIXEDSPEED0_25,
				IDM_FIXEDSPEED0_1,
				0};
	int s = 0;
	int t = m_MenuIdTiming;

	while (speeds[s] != 0 && speeds[s] != m_MenuIdTiming)
		s++;

	if (speeds[s] == 0)
	{
		t = IDM_REALTIME;
	}
	else if (up)
	{
		if (s > 0)
			t = speeds[s-1];
	}
	else
	{
		if (speeds[s+1] != 0)
			t = speeds[s+1];
	}

	if (t != m_MenuIdTiming)
	{
		CheckMenuItem(m_hMenu, m_MenuIdTiming, MF_UNCHECKED);
		m_MenuIdTiming = t;
		CheckMenuItem(m_hMenu, m_MenuIdTiming, MF_CHECKED);
		TranslateTiming();
	}
}

/****************************************************************************/
void BeebWin::TranslateKeyMapping(void)
{
//--	switch (m_MenuIdKeyMapping)
//--	{
//--	default:
//--	case IDM_DEFAULTKYBDMAPPING:
//--		transTable = transTable1;
//--		break;
//--
//--	case IDM_LOGICALKYBDMAPPING:
//--		transTable = transTable1;
//--		break;
//--
//--	case IDM_USERKYBDMAPPING:
//--		transTable = UserKeymap;
//--		break;
//--	}
}

void BeebWin::SetImageName(char *DiscName,char Drive,char DType) {
//->
//--	strcpy(CDiscName[Drive],DiscName);
//--	CDiscType[Drive]=DType;
//--	DiscLoaded[Drive]=TRUE;
//--
//--	const int maxMenuItemLen = 100;
//--	char menuStr[maxMenuItemLen+1];
//--	char *fname = strrchr(CDiscName[Drive], '\\');
//--	if (fname == NULL)
//--		fname = strrchr(CDiscName[Drive], '/');
//--	if (fname == NULL)
//--		fname = CDiscName[Drive];
//--	else
//--		fname++;
//--
//--	sprintf(menuStr, "Eject Disc %d: ", Drive);
//--	strncat(menuStr, fname, maxMenuItemLen-strlen(menuStr));
//--	menuStr[maxMenuItemLen] = '\0';
//--
//--	MENUITEMINFO mii = {0};
//--	mii.cbSize = sizeof(mii);
//--	mii.fMask = MIIM_STRING;
//--	mii.fType = MFT_STRING;
//--	mii.dwTypeData = menuStr;
//--	SetMenuItemInfo(m_hMenu, Drive == 0 ? IDM_EJECTDISC0 : IDM_EJECTDISC1, FALSE, &mii);
//++

	strcpy(CDiscName[(int) Drive],DiscName);
	CDiscType[(int) Drive]=DType;
	DiscLoaded[(int) Drive]=TRUE;

	// in beebem_pages.cpp sets the eject button label.
	//SetNameForDisc(Drive, CDiscName[(int) Drive]);
//<-
}

void BeebWin::EjectDiscImage(int Drive)
{
	Eject8271DiscImage(Drive);
	Close1770Disc(Drive);

	strcpy(CDiscName[Drive], "");
	CDiscType[Drive] = 0;
	DiscLoaded[Drive] = FALSE;

//->	MENUITEMINFO mii = {0};
//--	mii.cbSize = sizeof(mii);
//--	mii.fMask = MIIM_STRING;
//--	mii.fType = MFT_STRING;

	if (Drive == 0)
	{
//--		mii.dwTypeData = "Eject Disc 0";
//--		SetMenuItemInfo(m_hMenu, IDM_EJECTDISC0, FALSE, &mii);
		EnableMenuItem(m_hMenu, IDM_WPDISC0, MF_ENABLED );
		CheckMenuItem(m_hMenu, IDM_WPDISC0, MF_CHECKED);
	}
	else
	{
//--		mii.dwTypeData = "Eject Disc 1";
//--		SetMenuItemInfo(m_hMenu, IDM_EJECTDISC1, FALSE, &mii);
		EnableMenuItem(m_hMenu, IDM_WPDISC1, MF_ENABLED );
		CheckMenuItem(m_hMenu, IDM_WPDISC1, MF_CHECKED);
	}

//+>
	//SetNameForDisc(Drive, CDiscName[Drive]);
//<+
}

/****************************************************************************/
int BeebWin::ReadDisc(int Drive,HMENU dmenu)
{
//--	char DefaultPath[_MAX_PATH];
//->	char FileName[256];
//++
	static char FileName[1024]="";
//<-

//+>
        SysReg.GetStringValue(HKEY_CURRENT_USER, CFG_REG_KEY, "DiscsPath", FileName);
//<+


//--	OPENFILENAME ofn;
	int gotName = false;
//--
//--	strcpy(DefaultPath, m_AppPath);
//--	strcat(DefaultPath, "discims");
//--	SysReg.GetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,"DiscsPath",DefaultPath);
//--
//--	ofn.nFilterIndex = 1;
//--	FileName[0] = '\0';
//--
//--	/* Hmm, what do I put in all these fields! */
//--	ofn.lStructSize = sizeof(OPENFILENAME);
//--	ofn.hwndOwner = m_hWnd;
//--	ofn.hInstance = NULL;
//--	ofn.lpstrFilter = "Auto (*.ssd;*.dsd;*.ad*;*.img)\0*.ssd;*.dsd;*.adl;*.adf;*.img\0"
//--                    "ADFS Disc (*.adl *.adf)\0*.adl;*.adf\0"
//--                    "Single Sided Disc (*.ssd)\0*.ssd\0"
//--                    "Double Sided Disc (*.dsd)\0*.dsd\0"
//--                    "Single Sided Disc (*.*)\0*.*\0"
//--                    "Double Sided Disc (*.*)\0*.*\0";
//--	ofn.lpstrCustomFilter = NULL;
//--	ofn.nMaxCustFilter = 0;
//--	ofn.lpstrFile = FileName;
//--	ofn.nMaxFile = sizeof(FileName);
//--	ofn.lpstrFileTitle = NULL;
//--	ofn.nMaxFileTitle = 0;
//--	ofn.lpstrInitialDir = DefaultPath;
//--	ofn.lpstrTitle = NULL;
//--	ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
//--	ofn.nFileOffset = 0;
//--	ofn.nFileExtension = 0;
//--	ofn.lpstrDefExt = NULL;
//--	ofn.lCustData = 0;
//--	ofn.lpfnHook = NULL;
//--	ofn.lpTemplateName = NULL;
//--
//--	gotName = GetOpenFileName(&ofn);

//+>
//<+

	////XXX fix this  gotName = Open_GTK_File_Selector(FileName);

	if (gotName)
	{
//--		unsigned PathLength = strrchr(FileName, '\\') - FileName;
//--		strncpy(DefaultPath, FileName, PathLength);
//--		DefaultPath[PathLength] = 0;
//--		SysReg.SetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,"DiscsPath",DefaultPath);

//+>
		SysReg.SetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,"DiscsPath",FileName);
//<+

//--
		bool dsd = false;
		bool adfs = false;
		bool img = false;
		bool dos = false;
//--		switch (ofn.nFilterIndex)
//--		{
//--		case 1:
//--			{
			char *ext = strrchr(FileName, '.');
			if (ext != NULL)
			  if (stricmp(ext+1, "dsd") == 0)
				dsd = true;
			  if (stricmp(ext+1, "adl") == 0)
				adfs = true;
			  if (stricmp(ext+1, "adf") == 0)
				adfs = true;
			  if (stricmp(ext+1, "img") == 0)
				img = true;
			  if (stricmp(ext+1, "dos") == 0)
				dos = true;
//--			break;
//--			}
//--		case 2:
//--			adfs=true;
//--			break;
//--		case 4:
//--		case 6:
//--			dsd = true;
//--		}
//--
		// Another Master 128 Update, brought to you by Richard Gellman
		if (MachineType!=3)
		{
			if (dsd)
			{
				if (NativeFDC)
					LoadSimpleDSDiscImage(FileName, Drive, 80);
				else
					Load1770DiscImage(FileName,Drive,1,dmenu); // 1 = dsd
			}
			if ((!dsd) && (!adfs) && (!dos))
			{
				if (NativeFDC)
					LoadSimpleDiscImage(FileName, Drive, 0, 80);
				else
					Load1770DiscImage(FileName,Drive,0,dmenu); // 0 = ssd
			}
			if (adfs)
			{
				if (NativeFDC)
					MessageBox(GETHWND,"The native 8271 FDC cannot read ADFS discs\n","BeebEm",MB_OK|MB_ICONERROR);
				else
					Load1770DiscImage(FileName,Drive,2,dmenu); // 2 = adfs
			}
		}

		if (MachineType==3)
		{
			if (dsd)
				Load1770DiscImage(FileName,Drive,1,dmenu); // 0 = ssd
			if (!dsd && !adfs && !img && !dos)				 // Here we go a transposing...
				Load1770DiscImage(FileName,Drive,0,dmenu); // 1 = dsd
			if (adfs)
				Load1770DiscImage(FileName,Drive,2,dmenu); // ADFS OO La La!
			if (img)
				Load1770DiscImage(FileName,Drive,3,dmenu);
			if (dos)
				Load1770DiscImage(FileName,Drive,4,dmenu);
		}

		/* Write protect the disc */
		if (!m_WriteProtectDisc[Drive])
			ToggleWriteProtect(Drive);
	}

	return(gotName);
}

/****************************************************************************/
void BeebWin::LoadTape(void)
{
//--	char DefaultPath[_MAX_PATH];
//--	char FileName[256];
//--	OPENFILENAME ofn;
//--
//--	strcpy(DefaultPath, m_AppPath);
//--	strcat(DefaultPath, "tapes");
//--	SysReg.GetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TapesPath",DefaultPath);
//--
//--	ofn.nFilterIndex = 1;
//--	FileName[0] = '\0';
//--
//--	/* Hmm, what do I put in all these fields! */
//--	ofn.lStructSize = sizeof(OPENFILENAME);
//--	ofn.hwndOwner = m_hWnd;
//--	ofn.hInstance = NULL;
//--	ofn.lpstrFilter = "UEF Tape File (*.uef)\0*.uef\0"
//--					  "CSW Tape File (*.csw)\0*.csw\0";
//--	ofn.lpstrCustomFilter = NULL;
//--	ofn.nMaxCustFilter = 0;
//--	ofn.lpstrFile = FileName;
//--	ofn.nMaxFile = sizeof(FileName);
//--	ofn.lpstrFileTitle = NULL;
//--	ofn.nMaxFileTitle = 0;
//--	ofn.lpstrInitialDir = DefaultPath;
//--	ofn.lpstrTitle = NULL;
//--	ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
//--	ofn.nFileOffset = 0;
//--	ofn.nFileExtension = 0;
//--	ofn.lpstrDefExt = NULL;
//--	ofn.lCustData = 0;
//--	ofn.lpfnHook = NULL;
//--	ofn.lpTemplateName = NULL;
//--
//--	if (GetOpenFileName(&ofn))
//--	{
//--		unsigned PathLength = strrchr(FileName, '\\') - FileName;
//--		strncpy(DefaultPath, FileName, PathLength);
//--		DefaultPath[PathLength] = 0;
//--		SysReg.SetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TapesPath",DefaultPath);
//--
//--		if (strstr(FileName, ".uef")) LoadUEF(FileName);
//--		if (strstr(FileName, ".csw")) LoadCSW(FileName);
//--	}
}

void BeebWin::NewTapeImage(char *FileName)
{
//--	char DefaultPath[_MAX_PATH];
//--	OPENFILENAME ofn;
//--
//--	strcpy(DefaultPath, m_AppPath);
//--	strcat(DefaultPath, "tapes");
//--	SysReg.GetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TapesPath",DefaultPath);
//--
//--	ofn.nFilterIndex = 1;
//--	FileName[0] = '\0';
//--
//--	ofn.lStructSize = sizeof(OPENFILENAME);
//--	ofn.hwndOwner = m_hWnd;
//--	ofn.hInstance = NULL;
//--	ofn.lpstrFilter = "UEF Tape File (*.uef)\0*.uef\0";
//--	ofn.lpstrCustomFilter = NULL;
//--	ofn.nMaxCustFilter = 0;
//--	ofn.lpstrFile = FileName;
//--	ofn.nMaxFile = 256;
//--	ofn.lpstrFileTitle = NULL;
//--	ofn.nMaxFileTitle = 0;
//--	ofn.lpstrInitialDir = DefaultPath;
//--	ofn.lpstrTitle = NULL;
//--	ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
//--	ofn.nFileOffset = 0;
//--	ofn.nFileExtension = 0;
//--	ofn.lpstrDefExt = NULL;
//--	ofn.lCustData = 0;
//--	ofn.lpfnHook = NULL;
//--	ofn.lpTemplateName = NULL;
//--
//--	if (GetSaveFileName(&ofn))
//--	{
//--		/* Add a file extension if the user did not specify one */
//--		if (strchr(FileName, '.') == NULL)
//--		{
//--			strcat(FileName, ".uef");
//--		}
//--	}
//--	else
//--	{
//--		FileName[0] = '\0';
//--	}
}

/*******************************************************************/

void BeebWin::SelectFDC(void)
{
}

/****************************************************************************/
void BeebWin::NewDiscImage(int Drive)
{
}

/****************************************************************************/
void BeebWin::SaveState()
{
	static char FileName[1024]="";
	snprintf(FileName, _MAX_PATH, "%s/save/%s.uef", m_AppPath, mainWin->m_save_name);
	printf("saving %s\n", FileName);
	SaveUEFState(FileName);
	sync();
}

/****************************************************************************/
void BeebWin::RestoreState()
{
	static char FileName[1024] = "";
	snprintf(FileName, _MAX_PATH, "%s/save/%s.uef", m_AppPath, mainWin->m_save_name);
	LoadUEFState(FileName);
}

/****************************************************************************/
void BeebWin::ToggleWriteProtect(int Drive)
{
	HMENU hMenu = m_hMenu;
	if (MachineType!=3)
	{
		if (m_WriteProtectDisc[Drive])
		{
			m_WriteProtectDisc[Drive] = 0;
			DiscWriteEnable(Drive, 1);
		}
		else
		{
			m_WriteProtectDisc[Drive] = 1;
			DiscWriteEnable(Drive, 0);
		}

		if (Drive == 0)
			CheckMenuItem(hMenu, IDM_WPDISC0, m_WriteProtectDisc[0] ? MF_CHECKED : MF_UNCHECKED);
		else
			CheckMenuItem(hMenu, IDM_WPDISC1, m_WriteProtectDisc[1] ? MF_CHECKED : MF_UNCHECKED);
	}
	if (MachineType==3)
	{
		DWriteable[Drive]=1-DWriteable[Drive];
		if (Drive == 0)
			CheckMenuItem(hMenu, IDM_WPDISC0, DWriteable[0] ? MF_UNCHECKED : MF_CHECKED);
		else
			CheckMenuItem(hMenu, IDM_WPDISC1, DWriteable[1] ? MF_UNCHECKED : MF_CHECKED);
	}
}

void BeebWin::SetDiscWriteProtects(void)
{
	if (MachineType!=3)
	{
		m_WriteProtectDisc[0] = !IsDiscWritable(0);
		m_WriteProtectDisc[1] = !IsDiscWritable(1);
		CheckMenuItem(m_hMenu, IDM_WPDISC0, m_WriteProtectDisc[0] ? MF_CHECKED : MF_UNCHECKED);
		CheckMenuItem(m_hMenu, IDM_WPDISC1, m_WriteProtectDisc[1] ? MF_CHECKED : MF_UNCHECKED);
	}
	else
	{
		CheckMenuItem(m_hMenu, IDM_WPDISC0, DWriteable[0] ? MF_UNCHECKED : MF_CHECKED);
		CheckMenuItem(m_hMenu, IDM_WPDISC1, DWriteable[1] ? MF_UNCHECKED : MF_CHECKED);
	}
}

/****************************************************************************/
BOOL BeebWin::PrinterFile()
{
	return(0);
}

/****************************************************************************/
void BeebWin::TogglePrinter()
{
}

/****************************************************************************/
void BeebWin::TranslatePrinterPort()
{
	switch (m_MenuIdPrinterPort)
	{
	case IDM_PRINTER_FILE:
		strcpy(m_PrinterDevice, m_PrinterFileName);
		break;
	default:
	case IDM_PRINTER_LPT1:
		strcpy(m_PrinterDevice, "LPT1");
		break;
	case IDM_PRINTER_LPT2:
		strcpy(m_PrinterDevice, "LPT2");
		break;
	case IDM_PRINTER_LPT3:
		strcpy(m_PrinterDevice, "LPT3");
		break;
	case IDM_PRINTER_LPT4:
		strcpy(m_PrinterDevice, "LPT4");
		break;
	}
}

/****************************************************************************/
void BeebWin::LoadPreferences()
{
	int LEDByte=0;
	char DefValue[256];
	char CfgValue[256];
	unsigned char flag;
	DWORD dword;

	*binsize=1;

	MachineType=0;
	m_DirectDrawEnabled=0;
	m_DDFullScreenMode=ID_VIEW_DD_640X480;
	m_isDD32=0;
	m_MenuIdWinSize=IDM_640X512;
	m_isFullScreen=0;

	TranslateWindowSize();

	m_ShowSpeedAndFPS=1;
	palette_type = RGB;
	HideMenuEnabled=0;
	LEDByte=0;
	DiscLedColour=LED_COLOUR_TYPE;
	LEDs.ShowDisc=LED_SHOW_DISC;
	LEDs.ShowKB=LED_SHOW_KB;
	m_MotionBlur = IDM_BLUR_OFF;
	m_BlurIntensities[0]=100;
	m_BlurIntensities[1]=88;
	m_BlurIntensities[2]=75;
	m_BlurIntensities[3]=62;
	m_BlurIntensities[4]=50;
	m_BlurIntensities[5]=38;
	m_BlurIntensities[6]=25;
	m_BlurIntensities[7]=12;

	//XXX ZZZ ultra dodgy
//		cfg_Fullscreen_Resolution = RESOLUTION_640X480_V;

//		cfg_Fullscreen_Resolution = RESOLUTION_320X240_V;
			cfg_Fullscreen_Resolution = RESOLUTION_320X240_S;

# if 0 //LUDO: FOR_TEST
	m_MenuIdTiming = IDM_REALTIME;
# else
	//LUDO: m_MenuIdTiming = IDM_50FPS;
	m_MenuIdTiming = IDM_25FPS;
# endif
//<-
	TranslateTiming();

		SoundEnabled = 0;

		MachineType=0;
	m_isFullScreen=1;
//<-
	TranslateWindowSize();

	DiscLedColour=LED_COLOUR_TYPE;
	LEDs.ShowDisc=LED_SHOW_DISC;
	LEDs.ShowKB=LED_SHOW_KB;
}

/****************************************************************************/
void BeebWin::SavePreferences()
{
	int LEDByte=0;
//--	char CfgName[256];
	unsigned char flag;
//--	char keyData[256];
//--	int key;

	*binsize=1;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"MachineType",&MachineType,binsize);

	flag = m_DirectDrawEnabled;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_VIEW_DIRECT_ENABLED,&flag,binsize);
	flag = m_DDS2InVideoRAM;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_VIEW_BUFFER_IN_VIDEO,&flag,binsize);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,"DDFullScreenMode",m_DDFullScreenMode);
	flag = m_isDD32;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"isDD32",&flag,binsize);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_VIEW_WIN_SIZE,m_MenuIdWinSize);
	flag = m_isFullScreen;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"isFullScreen",&flag,binsize);
	flag = m_ShowSpeedAndFPS;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_VIEW_SHOW_FPS,&flag,binsize);
	flag = palette_type;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_VIEW_MONITOR,&flag,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"HideMenuEnabled",&HideMenuEnabled,binsize);
	LEDByte=(DiscLedColour<<2)|((LEDs.ShowDisc?1:0)<<1)|(LEDs.ShowKB?1:0);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"LED Information",&LEDByte,binsize);
	flag = m_MotionBlur;
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, "MotionBlur", m_MotionBlur);
	*binsize=8;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"MotionBlurIntensities",m_BlurIntensities,binsize);
	*binsize=1;

	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_SPEED_TIMING, m_MenuIdTiming);

	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_SOUND_ENABLED,&SoundDefault,binsize);
	flag = SoundChipEnabled;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"SoundChipEnabled",&flag,binsize);
	flag = DirectSoundEnabled;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_SOUND_DIRECT_ENABLED,&flag,binsize);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_SOUND_SAMPLE_RATE, m_MenuIdSampleRate);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_SOUND_VOLUME, m_MenuIdVolume);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"RelaySoundEnabled",&RelaySoundEnabled,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TapeSoundEnabled",&TapeSoundEnabled,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"UsePrimaryBuffer",&UsePrimaryBuffer,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"Part Samples",&PartSamples,binsize);
//	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"UseHostClock",&UseHostClock,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"ExponentialVolume",&SoundExponentialVolume,binsize);

	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_OPTIONS_STICKS, m_MenuIdSticks);
	flag = m_FreezeWhenInactive;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_OPTIONS_FREEZEINACTIVE,&flag,binsize);
	flag = m_HideCursor;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_OPTIONS_HIDE_CURSOR,&flag,binsize);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_OPTIONS_KEY_MAPPING, m_MenuIdKeyMapping);
	flag = m_KeyMapAS;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"KeyMapAS",&flag,binsize);
	flag = m_KeyMapFunc;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"KeyMapFunc",&flag,binsize);

	*binsize=1;
	flag = AMXMouseEnabled;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_AMX_ENABLED,&flag,binsize);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_AMX_LRFORMIDDLE, AMXLRForMiddle);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_AMX_SIZE, m_MenuIdAMXSize);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_AMX_ADJUST, m_MenuIdAMXAdjust);

	flag = PrinterEnabled;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_PRINTER_ENABLED,&flag,binsize);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_PRINTER_PORT, m_MenuIdPrinterPort);
	SysReg.SetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY, CFG_PRINTER_FILE, m_PrinterFileName);

	*binsize=2;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"Tape Clock Speed",&TapeClockSpeed,binsize);
	*binsize=1;
	flag=UnlockTape;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"UnlockTape",&flag,binsize);

	//SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TouchScreenEnabled",&TouchScreenEnabled,binsize);

	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"SerialPortEnabled",&SerialPortEnabled,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"SerialPort",&SerialPort,binsize);

#ifdef WITH_ECONET
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"EconetEnabled",&EconetEnabled,binsize); //Rob
#endif

	flag=SpeechDefault;
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"SpeechEnabled",&flag,binsize);

	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TorchTube",&TorchTube,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"AcornZ80",&AcornZ80,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"Tube186Enabled",&Tube186Enabled,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TubeEnabled",&TubeEnabled,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"OpCodes",&OpCodes,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"Basic Hardware",&BHardware,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"Teletext Half Mode",&THalfMode,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"SoundBlockSize",&SBSize,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"TeleTextAdapterEnabled",&TeleTextAdapterEnabled,binsize);
	SysReg.SetBinaryValue(HKEY_CURRENT_USER,CFG_REG_KEY,"HardDriveEnabled",&HardDriveEnabled,binsize);

	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,"CaptureResolution",m_MenuIdAviResolution);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,"FrameSkip",m_MenuIdAviSkip);

//+>
	// Additional BeebEm SDL options:

	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_EMULATECRTGRAPHICS, cfg_EmulateCrtGraphics);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_EMUALTECRTTELETEXT, cfg_EmulateCrtTeletext);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_WANTLOWLATENCYSOUND, cfg_WantLowLatencySound);
	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_SLEEP_TYPE,cfg_WaitType);

	SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_WINDOWEDRESOLUTION, cfg_Windowed_Resolution);
       SysReg.SetDWORDValue(HKEY_CURRENT_USER,CFG_REG_KEY,CFG_FULLSCREENRESOLUTION,cfg_Fullscreen_Resolution);

//<+

}

void BeebWin::SaveOnExit(void)
{
//--	char TmpPath[256];
//--
//--	// write out cmos ram first
//--	strcpy(TmpPath,RomPath);
//--	strcat(TmpPath,"/beebstate/cmos.ram");
//--	CMDF2=fopen(TmpPath,"wb");
//--	if (CMDF2 != NULL)
//--	{
//--		for(CMA2=0xe;CMA2<64;CMA2++)
//--			fputc(CMOSRAM[CMA2],CMDF2);
//--		fclose(CMDF2);
//--	}
//--
//--	if (!m_isFullScreen)
//--		SaveWindowPos(); // Save window co-ordinates
}
		
/****************************************************************************/
void BeebWin::SetTapeSpeedMenu(void) {
	CheckMenuItem(m_hMenu,ID_TAPE_FAST,(TapeClockSpeed==750)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_TAPE_MFAST,(TapeClockSpeed==1600)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_TAPE_MSLOW,(TapeClockSpeed==3200)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_TAPE_NORMAL,(TapeClockSpeed==5600)?MF_CHECKED:MF_UNCHECKED);
}

/****************************************************************************/
void BeebWin::SetWindowAttributes(bool wasFullScreen)
{
}

/****************************************************************************/
void BeebWin::TranslateAMX(void)
{
	switch (m_MenuIdAMXSize)
	{
	case IDM_AMX_160X256:
		m_AMXXSize = 160;
		m_AMXYSize = 256;
		break;
	default:
	case IDM_AMX_320X256:
		m_AMXXSize = 320;
		m_AMXYSize = 256;
		break;
	case IDM_AMX_640X256:
		m_AMXXSize = 640;
		m_AMXYSize = 256;
		break;
	}

	switch (m_MenuIdAMXAdjust)
	{
	case 0:
		m_AMXAdjust = 0;
		break;
	case IDM_AMX_ADJUSTP50:
		m_AMXAdjust = 50;
		break;
	default:
	case IDM_AMX_ADJUSTP30:
		m_AMXAdjust = 30;
		break;
	case IDM_AMX_ADJUSTP10:
		m_AMXAdjust = 10;
		break;
	case IDM_AMX_ADJUSTM10:
		m_AMXAdjust = -10;
		break;
	case IDM_AMX_ADJUSTM30:
		m_AMXAdjust = -30;
		break;
	case IDM_AMX_ADJUSTM50:
		m_AMXAdjust = -50;
		break;
	}
}

void BeebWin::UpdateSerialMenu(HMENU hMenu) {
	CheckMenuItem(hMenu, ID_SERIAL, (SerialPortEnabled)?MF_CHECKED:MF_UNCHECKED);
	//CheckMenuItem(hMenu, ID_TOUCHSCREEN, (TouchScreenEnabled)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_COM1, (SerialPort==1)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_COM2, (SerialPort==2)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_COM3, (SerialPort==3)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_COM4, (SerialPort==4)?MF_CHECKED:MF_UNCHECKED);
}

//Rob
void BeebWin::UpdateEconetMenu(HMENU hMenu) {	
#ifdef WITH_ECONET
	CheckMenuItem(hMenu, ID_ECONET, (EconetEnabled)?MF_CHECKED:MF_UNCHECKED);
#endif
}

void BeebWin::UpdateLEDMenu(HMENU hMenu) {
	// Update the LED Menu
	CheckMenuItem(hMenu,ID_RED_LEDS,(DiscLedColour>0)?MF_UNCHECKED:MF_CHECKED);
	CheckMenuItem(hMenu,ID_GREEN_LEDS,(DiscLedColour>0)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu,ID_SHOW_KBLEDS,(LEDs.ShowKB)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hMenu,ID_SHOW_DISCLEDS,(LEDs.ShowDisc)?MF_CHECKED:MF_UNCHECKED);
}

void BeebWin::UpdateOptiMenu(void) {
	CheckMenuItem(m_hMenu,ID_DOCONLY,(OpCodes==1)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_EXTRAS ,(OpCodes==2)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_FULLSET,(OpCodes==3)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_BHARDWARE,(BHardware==1)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_TSTYLE,(THalfMode==1)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_1773,(SBSize==1)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_443,(SBSize==0)?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(m_hMenu,ID_PSAMPLES,(PartSamples)?MF_CHECKED:MF_UNCHECKED);
}
/***************************************************************************/
void BeebWin::HandleCommand(int MenuId)
{
//--	char TmpPath[256];
//--	HRESULT ddrval;
	HMENU hMenu = m_hMenu;
	int prev_palette_type = palette_type;

	SetSound(MUTED);

	switch (MenuId)
	{
	case IDM_RUNDISC:
		if (ReadDisc(0,hMenu))
		{
			m_ShiftBooted = true;
			ResetBeebSystem(MachineType,TubeEnabled,0);
			BeebKeyDown(0, 0); // Shift key
		}
		MustEnableSound=TRUE;
		break;

	case IDM_LOADSTATE:
		RestoreState();
		MustEnableSound=TRUE;
		break;
	case IDM_SAVESTATE:
		SaveState();
		MustEnableSound=TRUE;
		break;

	case IDM_QUICKLOAD:
		QuickLoad();
		break;
	case IDM_QUICKSAVE:
		QuickSave();
		break;

	case IDM_LOADDISC0:
		ReadDisc(0,hMenu);
		MustEnableSound=TRUE;
		break;
	case IDM_LOADDISC1:
		ReadDisc(1,hMenu);
		MustEnableSound=TRUE;
		break;
	
	case ID_LOADTAPE:
		LoadTape();
		MustEnableSound=TRUE;
		break;

	case IDM_NEWDISC0:
		NewDiscImage(0);
		MustEnableSound=TRUE;
		break;
	case IDM_NEWDISC1:
		NewDiscImage(1);
		MustEnableSound=TRUE;
		break;

	// *****************************************************************************
	// NEW OPTIONS
	case IDM_EJECTDISC0:
		EjectDiscImage(0);
		break;
	case IDM_EJECTDISC1:
		EjectDiscImage(1);
		break;
	// ****************************************************************************

	case IDM_WPDISC0:
		ToggleWriteProtect(0);
		break;
	case IDM_WPDISC1:
		ToggleWriteProtect(1);
		break;

	case IDM_PRINTER_FILE:
		if (PrinterFile())
		{
			/* If printer is enabled then need to
				disable it before changing file */
			if (PrinterEnabled)
				TogglePrinter();

			/* Add file name to menu */
			char menu_string[256];
			strcpy(menu_string, "File: ");
			strcat(menu_string, m_PrinterFileName);
			ModifyMenu(hMenu, IDM_PRINTER_FILE,
				MF_BYCOMMAND, IDM_PRINTER_FILE,
				menu_string);

			if (MenuId != m_MenuIdPrinterPort)
			{
				CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_UNCHECKED);
				m_MenuIdPrinterPort = MenuId;
				CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_CHECKED);
   			}
			TranslatePrinterPort();
		}
		MustEnableSound=TRUE;
		break;
	case IDM_PRINTER_LPT1:
	case IDM_PRINTER_LPT2:
	case IDM_PRINTER_LPT3:
	case IDM_PRINTER_LPT4:
		if (MenuId != m_MenuIdPrinterPort)
		{
			/* If printer is enabled then need to
				disable it before changing file */
			if (PrinterEnabled)
				TogglePrinter();

			CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_UNCHECKED);
			m_MenuIdPrinterPort = MenuId;
			CheckMenuItem(hMenu, m_MenuIdPrinterPort, MF_CHECKED);
			TranslatePrinterPort();
   		}
		break;
	case IDM_PRINTERONOFF:
		TogglePrinter();
		break;

	case ID_SERIAL:
		/*if (TouchScreenEnabled)
		{
			TouchScreenClose();
			TouchScreenEnabled = false;
		}*/

		SerialPortEnabled=1-SerialPortEnabled;
		bSerialStateChanged=TRUE;
		UpdateSerialMenu(hMenu);
		break;

	case ID_TOUCHSCREEN:

		/*if (TouchScreenEnabled)
		{
			TouchScreenClose();
		}
				
		TouchScreenEnabled = 1 - TouchScreenEnabled;

		if (TouchScreenEnabled)
		{
			// Also switch on analogue mousestick (touch screen uses
			// mousestick position)
			if (m_MenuIdSticks != IDM_AMOUSESTICK)
				HandleCommand(IDM_AMOUSESTICK);

			SerialPortEnabled = true;

			Kill_Serial();

			SerialPort = 0;
			bSerialStateChanged=TRUE;
			TouchScreenOpen();
		}
		UpdateSerialMenu(hMenu);*/
		break;

	case ID_COM1:
		//SerialPort=1; bSerialStateChanged=TRUE; TouchScreenEnabled = false; TouchScreenClose(); UpdateSerialMenu(hMenu); break;
	case ID_COM2:
		//SerialPort=2; bSerialStateChanged=TRUE; TouchScreenEnabled = false; TouchScreenClose(); UpdateSerialMenu(hMenu); break;

	case ID_COM3:
		//SerialPort=3; bSerialStateChanged=TRUE; TouchScreenEnabled = false; TouchScreenClose(); UpdateSerialMenu(hMenu); break;

	case ID_COM4:
		//SerialPort=4; bSerialStateChanged=TRUE; TouchScreenEnabled = false; TouchScreenClose(); UpdateSerialMenu(hMenu); break;
		break;

	//Rob
	case ID_ECONET:
#ifdef WITH_ECONET
		EconetEnabled= 1-EconetEnabled;
		if (EconetEnabled)
		{
			// Need hard reset for DNFS to detect econet HW
			ResetBeebSystem(MachineType,TubeEnabled,0);
			EconetStateChanged=TRUE;
		}
		else
		{
			EconetReset();
		}
		UpdateEconetMenu(hMenu);
#endif
		break;

	case IDM_FULLSCREEN:
		m_isFullScreen = !m_isFullScreen;
		CheckMenuItem(hMenu, IDM_FULLSCREEN, m_isFullScreen ? MF_CHECKED : MF_UNCHECKED);
		TranslateWindowSize();
		SetWindowAttributes(!m_isFullScreen);
		break;

	case IDM_SPEEDANDFPS:
		if (m_ShowSpeedAndFPS)
		{
			m_ShowSpeedAndFPS = FALSE;
			CheckMenuItem(hMenu, IDM_SPEEDANDFPS, MF_UNCHECKED);
			SetWindowText(m_hWnd, WindowTitle);
		}
		else
		{
			m_ShowSpeedAndFPS = TRUE;
			CheckMenuItem(hMenu, IDM_SPEEDANDFPS, MF_CHECKED);
		}
		break;
	
	case IDM_SOUNDONOFF:
		if (SoundDefault)
		{
			CheckMenuItem(hMenu, IDM_SOUNDONOFF, MF_UNCHECKED);
			SoundReset();
			SoundDefault=0;
		}
		else
		{
			SoundInit();
			if (SoundEnabled) {
				CheckMenuItem(hMenu, IDM_SOUNDONOFF, MF_CHECKED);
				SoundDefault=1;
			}
		}
		break;
//--	case IDM_SOUNDCHIP:
//--		SoundChipEnabled=1-SoundChipEnabled;
//--		CheckMenuItem(hMenu, IDM_SOUNDCHIP, SoundChipEnabled?MF_CHECKED:MF_UNCHECKED);
//--		break;

	case ID_SFX_RELAY:
		RelaySoundEnabled=1-RelaySoundEnabled;
		CheckMenuItem(hMenu,ID_SFX_RELAY,RelaySoundEnabled?MF_CHECKED:MF_UNCHECKED);
		break;

	case IDM_44100KHZ:
	case IDM_22050KHZ:
	case IDM_11025KHZ:
		if (MenuId != m_MenuIdSampleRate)
		{
			CheckMenuItem(hMenu, m_MenuIdSampleRate, MF_UNCHECKED);
			m_MenuIdSampleRate = MenuId;
			CheckMenuItem(hMenu, m_MenuIdSampleRate, MF_CHECKED);
			TranslateSampleRate();

			if (SoundEnabled)
			{
				SoundReset();
				SoundInit();
			}

			if (SpeechDefault)
			{
				tms5220_stop();
				tms5220_start();
			}
		}
		break;
	
	case IDM_FULLVOLUME:
	case IDM_HIGHVOLUME:
	case IDM_MEDIUMVOLUME:
	case IDM_LOWVOLUME:
		if (MenuId != m_MenuIdVolume)
		{
			CheckMenuItem(hMenu, m_MenuIdVolume, MF_UNCHECKED);
			m_MenuIdVolume = MenuId;
			CheckMenuItem(hMenu, m_MenuIdVolume, MF_CHECKED);
			TranslateVolume();
		}
		break;
	
	/* LRW Added switch individual ROMS Writable ON/OFF */
	case IDM_ALLOWWRITES_ROM0:
	case IDM_ALLOWWRITES_ROM1:
	case IDM_ALLOWWRITES_ROM2:
	case IDM_ALLOWWRITES_ROM3:
	case IDM_ALLOWWRITES_ROM4:
	case IDM_ALLOWWRITES_ROM5:
	case IDM_ALLOWWRITES_ROM6:
	case IDM_ALLOWWRITES_ROM7:
	case IDM_ALLOWWRITES_ROM8:
	case IDM_ALLOWWRITES_ROM9:
	case IDM_ALLOWWRITES_ROMA:
	case IDM_ALLOWWRITES_ROMB:
	case IDM_ALLOWWRITES_ROMC:
	case IDM_ALLOWWRITES_ROMD:
	case IDM_ALLOWWRITES_ROME:
	case IDM_ALLOWWRITES_ROMF:

		CheckMenuItem(hMenu,  MenuId, RomWritable[( MenuId-IDM_ALLOWWRITES_ROM0)] ? MF_UNCHECKED : MF_CHECKED );
		GetRomMenu();	// Update the Rom/Ram state for all the roms.
		break;				

	case IDM_REALTIME:
	case IDM_FIXEDSPEED100:
	case IDM_FIXEDSPEED50:
	case IDM_FIXEDSPEED10:
	case IDM_FIXEDSPEED5:
	case IDM_FIXEDSPEED2:
	case IDM_FIXEDSPEED1_5:
	case IDM_FIXEDSPEED1_25:
	case IDM_FIXEDSPEED1_1:
	case IDM_FIXEDSPEED0_9:
	case IDM_FIXEDSPEED0_5:
	case IDM_FIXEDSPEED0_75:
	case IDM_FIXEDSPEED0_25:
	case IDM_FIXEDSPEED0_1:
	case IDM_50FPS:
	case IDM_25FPS:
	case IDM_10FPS:
	case IDM_5FPS:
	case IDM_1FPS:
		if (MenuId != m_MenuIdTiming)
		{
			CheckMenuItem(hMenu, m_MenuIdTiming, MF_UNCHECKED);
			m_MenuIdTiming = MenuId;
			CheckMenuItem(hMenu, m_MenuIdTiming, MF_CHECKED);
			TranslateTiming();
		}
		break;

	case IDM_JOYSTICK:
	case IDM_AMOUSESTICK:
	case IDM_DMOUSESTICK:
		/* Disable current selection */
		if (m_MenuIdSticks != 0)
		{
			CheckMenuItem(hMenu, m_MenuIdSticks, MF_UNCHECKED);
			if (m_MenuIdSticks == IDM_JOYSTICK)
			{
				ResetJoystick();
			}
			else /* mousestick */
			{
				AtoDReset();
			}
		}

		if (MenuId == m_MenuIdSticks)
		{
			/* Joysticks switched off completely */
			m_MenuIdSticks = 0;
		}
		else
		{
			/* Initialise new selection */
			m_MenuIdSticks = MenuId;
			if (m_MenuIdSticks == IDM_JOYSTICK)
			{
				InitJoystick();
			}
			else /* mousestick */
			{
				AtoDInit();
			}
			if (JoystickEnabled)
				CheckMenuItem(hMenu, m_MenuIdSticks, MF_CHECKED);
			else
				m_MenuIdSticks = 0;
		}
		break;

	case IDM_FREEZEINACTIVE:
		if (m_FreezeWhenInactive)
		{
			m_FreezeWhenInactive = FALSE;
			CheckMenuItem(hMenu, IDM_FREEZEINACTIVE, MF_UNCHECKED);
		}
		else
		{
			m_FreezeWhenInactive = TRUE;
			CheckMenuItem(hMenu, IDM_FREEZEINACTIVE, MF_CHECKED);
		}
		break;

	case IDM_HIDECURSOR:
		if (m_HideCursor)
		{
			qDEBUG("Show mouse cursor\n");

			m_HideCursor = FALSE;
			CheckMenuItem(hMenu, IDM_HIDECURSOR, MF_UNCHECKED);
		}
		else
		{
			qDEBUG("Hide mouse cursor\n");

			m_HideCursor = TRUE;
			CheckMenuItem(hMenu, IDM_HIDECURSOR, MF_CHECKED);
		}
		break;

	case IDM_IGNOREILLEGALOPS:
		if (IgnoreIllegalInstructions)
		{
			IgnoreIllegalInstructions = FALSE;
			CheckMenuItem(hMenu, IDM_IGNOREILLEGALOPS, MF_UNCHECKED);
		}
		else
		{
			IgnoreIllegalInstructions = TRUE;
			CheckMenuItem(hMenu, IDM_IGNOREILLEGALOPS, MF_CHECKED);
		}
		break;

	case IDM_DEFINEKEYMAP:
		UserKeyboardDialog( m_hWnd );
		MustEnableSound=TRUE;
		break;

	case IDM_USERKYBDMAPPING:
	case IDM_DEFAULTKYBDMAPPING:
	case IDM_LOGICALKYBDMAPPING:
		if (MenuId != m_MenuIdKeyMapping)
		{
			CheckMenuItem(hMenu, m_MenuIdKeyMapping, MF_UNCHECKED);
			m_MenuIdKeyMapping = MenuId;
			CheckMenuItem(hMenu, m_MenuIdKeyMapping, MF_CHECKED);
			TranslateKeyMapping();
		}
		break;

	case IDM_MAPAS:
		if (m_KeyMapAS)
		{
			m_KeyMapAS = FALSE;
			CheckMenuItem(hMenu, IDM_MAPAS, MF_UNCHECKED);
		}
		else
		{
			m_KeyMapAS = TRUE;
			CheckMenuItem(hMenu, IDM_MAPAS, MF_CHECKED);
		}
		break;
	case IDM_MAPFUNCS:
		if (m_KeyMapFunc)
		{
			m_KeyMapFunc = FALSE;
			CheckMenuItem(hMenu, IDM_MAPFUNCS, MF_UNCHECKED);
		}
		else
		{
			m_KeyMapFunc = TRUE;
			CheckMenuItem(hMenu, IDM_MAPFUNCS, MF_CHECKED);
		}
		break;

	case IDM_SAVE_PREFS:
		SavePreferences();
		break;

	case IDM_AMXONOFF:
		if (AMXMouseEnabled)
		{
			CheckMenuItem(hMenu, IDM_AMXONOFF, MF_UNCHECKED);
			AMXMouseEnabled = FALSE;
		}
		else
		{
			CheckMenuItem(hMenu, IDM_AMXONOFF, MF_CHECKED);
			AMXMouseEnabled = TRUE;
		}
		break;

	case IDM_AMX_LRFORMIDDLE:
		if (AMXLRForMiddle)
		{
			CheckMenuItem(hMenu, IDM_AMX_LRFORMIDDLE, MF_UNCHECKED);
			AMXLRForMiddle = FALSE;
		}
		else
		{
			CheckMenuItem(hMenu, IDM_AMX_LRFORMIDDLE, MF_CHECKED);
			AMXLRForMiddle = TRUE;
		}
		break;

	case IDM_AMX_160X256:
	case IDM_AMX_320X256:
	case IDM_AMX_640X256:
		if (MenuId != m_MenuIdAMXSize)
		{
			CheckMenuItem(hMenu, m_MenuIdAMXSize, MF_UNCHECKED);
			m_MenuIdAMXSize = MenuId;
			CheckMenuItem(hMenu, m_MenuIdAMXSize, MF_CHECKED);
   		}
		TranslateAMX();
		break;

	case IDM_AMX_ADJUSTP50:
	case IDM_AMX_ADJUSTP30:
	case IDM_AMX_ADJUSTP10:
	case IDM_AMX_ADJUSTM10:
	case IDM_AMX_ADJUSTM30:
	case IDM_AMX_ADJUSTM50:
		if (m_MenuIdAMXAdjust != 0)
		{
			CheckMenuItem(hMenu, m_MenuIdAMXAdjust, MF_UNCHECKED);
		}

		if (MenuId != m_MenuIdAMXAdjust)
		{
			m_MenuIdAMXAdjust = MenuId;
			CheckMenuItem(hMenu, m_MenuIdAMXAdjust, MF_CHECKED);
   		}
		else
		{
			m_MenuIdAMXAdjust = 0;
		}
		TranslateAMX();
		break;

	case ID_MONITOR_RGB:
		palette_type = RGB;
		CreateBitmap();
		break;
	case ID_MONITOR_BW:
		palette_type = BW;
		CreateBitmap();
		break;
	case ID_MONITOR_GREEN:
		palette_type = GREEN;
		CreateBitmap();
		break;
	case ID_MONITOR_AMBER:
		palette_type = AMBER;
		CreateBitmap();
		break;

	case IDM_TUBE:
		TubeEnabled=1-TubeEnabled;
        Tube186Enabled = 0;
        TorchTube = 0;
		AcornZ80 = 0;
        CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
		ResetBeebSystem(MachineType,TubeEnabled,0);
		break;

	case IDM_TUBE186:
		Tube186Enabled=1-Tube186Enabled;
        TubeEnabled = 0;
        TorchTube = 0;
		AcornZ80 = 0;
        CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
		ResetBeebSystem(MachineType,TubeEnabled,0);
		break;

    case IDM_TORCH:
		TorchTube=1-TorchTube;
		TubeEnabled=0;
		Tube186Enabled=0;
		AcornZ80 = 0;
		CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
		ResetBeebSystem(MachineType,TubeEnabled,0);
		break;
    
    case IDM_ACORNZ80:
		AcornZ80=1-AcornZ80;
		TubeEnabled=0;
		TorchTube=0;
		Tube186Enabled=0;
		CheckMenuItem(hMenu, IDM_TUBE, (TubeEnabled)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_TUBE186, (Tube186Enabled)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_TORCH, (TorchTube)?MF_CHECKED:MF_UNCHECKED);
		CheckMenuItem(hMenu, IDM_ACORNZ80, (AcornZ80)?MF_CHECKED:MF_UNCHECKED);
		ResetBeebSystem(MachineType,TubeEnabled,0);
		break;

    case ID_FILE_RESET:
		ResetBeebSystem(MachineType,TubeEnabled,0);
		break;

	case ID_MODELB:
		if (MachineType!=0)
		{
			ResetBeebSystem(0,EnableTube,1);
			UpdateModelType();
		}
		break;
	case ID_MODELBINT:
		if (MachineType!=1)
		{
			ResetBeebSystem(1,EnableTube,1);
			UpdateModelType();
		}
		break;
	case ID_MODELBP:
		if (MachineType!=2)
		{
			ResetBeebSystem(2,EnableTube,1);
			UpdateModelType();
		}
		break;
	case ID_MASTER128:
		if (MachineType!=3)
		{
			ResetBeebSystem(3,EnableTube,1);
			UpdateModelType();
		}
		break;

	case ID_REWINDTAPE:
		RewindTape();
		break;
	case ID_UNLOCKTAPE:
		UnlockTape=1-UnlockTape;
		SetUnlockTape(UnlockTape);
		CheckMenuItem(hMenu, ID_UNLOCKTAPE, (UnlockTape)?MF_CHECKED:MF_UNCHECKED);
		break;

	case ID_HIDEMENU:
		HideMenuEnabled=1-HideMenuEnabled;
		CheckMenuItem(hMenu, ID_HIDEMENU, (HideMenuEnabled)?MF_CHECKED:MF_UNCHECKED);
		break;

	case ID_RED_LEDS:
		DiscLedColour=0;
		UpdateLEDMenu(hMenu);
		break;
	case ID_GREEN_LEDS:
		DiscLedColour=1;
		UpdateLEDMenu(hMenu);
		break;
	case ID_SHOW_KBLEDS:
		LEDs.ShowKB=!LEDs.ShowKB;
		UpdateLEDMenu(hMenu);
		break;
	case ID_SHOW_DISCLEDS:
		LEDs.ShowDisc=!LEDs.ShowDisc;
		UpdateLEDMenu(hMenu);
		break;

	case ID_FDC_DLL:
		if (MachineType != 3)
			SelectFDC();
		MustEnableSound=TRUE;
		break;
	case ID_8271:
		KillDLLs();
		NativeFDC=TRUE;
		CheckMenuItem(m_hMenu,ID_8271,MF_CHECKED);
		CheckMenuItem(m_hMenu,ID_FDC_DLL,MF_UNCHECKED);
//## here ->
		if (MachineType != 3)
		{
			char CfgName[20];
			if (MachineType == 0)
				strcpy(CfgName, "FDCDLL");
			else
				sprintf(CfgName, "FDCDLL%d", MachineType);
			SysReg.SetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,CfgName,"None");
		}
//## <- to here - was disabled.
		break;

	case ID_TAPE_FAST:
		SetTapeSpeed(750);
		SetTapeSpeedMenu();
		break;
	case ID_TAPE_MFAST:
		SetTapeSpeed(1600);
		SetTapeSpeedMenu();
		break;
	case ID_TAPE_MSLOW:
		SetTapeSpeed(3200);
		SetTapeSpeedMenu();
		break;
	case ID_TAPE_NORMAL:
		SetTapeSpeed(5600);
		SetTapeSpeedMenu();
		break;
	case ID_TAPESOUND:
		TapeSoundEnabled=!TapeSoundEnabled;
		CheckMenuItem(m_hMenu,ID_TAPESOUND,(TapeSoundEnabled)?MF_CHECKED:MF_UNCHECKED);
		break;

//--	case ID_TAPECONTROL:
//--		if (TapeControlEnabled)
//--			TapeControlCloseDialog();
//--		else
//--			TapeControlOpenDialog(hInst, m_hWnd);
//--		break;


	case ID_BREAKOUT:
//--		if (mBreakOutWindow)
//--			BreakOutCloseDialog();
//--		else
//--			BreakOutOpenDialog(hInst, m_hWnd);
		break;


//	case ID_HOSTCLOCK:
//		UseHostClock=1-UseHostClock;
//		CheckMenuItem(m_hMenu,ID_HOSTCLOCK,(UseHostClock)?MF_CHECKED:MF_UNCHECKED);
//		SoundReset();
//		if (SoundDefault) SoundInit();
//		break;
	case ID_PBUFF:
		UsePrimaryBuffer=1-UsePrimaryBuffer;
		SetPBuff();
		SoundReset();
		if (SoundDefault) SoundInit();
		break;
	case ID_TSTYLE:
		THalfMode=1-THalfMode;
		UpdateOptiMenu();
		break;

	case ID_DOCONLY:
		OpCodes=1;
		UpdateOptiMenu();
		break;
	case ID_EXTRAS:
		OpCodes=2;
		UpdateOptiMenu();
		break;
	case ID_FULLSET:
		OpCodes=3;
		UpdateOptiMenu();
		break;
	case ID_BHARDWARE:
		BHardware=1-BHardware;
		UpdateOptiMenu();
		break;
	case ID_PSAMPLES:
		PartSamples=1-PartSamples;
		UpdateOptiMenu();
		break;
	case ID_1773:
		SBSize=1;
		UpdateOptiMenu();
		break;
	case ID_443:
		SBSize=0;
		UpdateOptiMenu();
		break;

	// ***************************************************************************
	// NEW OPTIONS

	case IDM_EXPVOLUME:
		SoundExponentialVolume=1-SoundExponentialVolume;
		CheckMenuItem(m_hMenu, IDM_EXPVOLUME, SoundExponentialVolume ? MF_CHECKED:MF_UNCHECKED);
		break;
	// ***************************************************************************

	case IDM_BLUR_OFF:
	case IDM_BLUR_2:
	case IDM_BLUR_4:
	case IDM_BLUR_8:
		if (MenuId != m_MotionBlur)
		{
			CheckMenuItem(hMenu, m_MotionBlur, MF_UNCHECKED);
			m_MotionBlur = MenuId;
			CheckMenuItem(hMenu, m_MotionBlur, MF_CHECKED);
		}
		break;

	case IDM_VIDEORES1:
	case IDM_VIDEORES2:
	case IDM_VIDEORES3:
		if (MenuId != m_MenuIdAviResolution)
		{
			CheckMenuItem(hMenu, m_MenuIdAviResolution, MF_UNCHECKED);
			m_MenuIdAviResolution = MenuId;
			CheckMenuItem(hMenu, m_MenuIdAviResolution, MF_CHECKED);
		}
		break;
	case IDM_VIDEOSKIP0:
	case IDM_VIDEOSKIP1:
	case IDM_VIDEOSKIP2:
	case IDM_VIDEOSKIP3:
	case IDM_VIDEOSKIP4:
	case IDM_VIDEOSKIP5:
		if (MenuId != m_MenuIdAviSkip)
		{
			CheckMenuItem(hMenu, m_MenuIdAviSkip, MF_UNCHECKED);
			m_MenuIdAviSkip = MenuId;
			CheckMenuItem(hMenu, m_MenuIdAviSkip, MF_CHECKED);
		}
		break;

	case IDM_SPEECH:
		if (SpeechDefault)
		{
			CheckMenuItem(hMenu, IDM_SPEECH, MF_UNCHECKED);
			tms5220_stop();
			SpeechDefault = 0;
		}
		else
		{
			tms5220_start();
			if (SpeechEnabled)
			{
				CheckMenuItem(hMenu, IDM_SPEECH, MF_CHECKED);
				SpeechDefault = 1;
			}
		}
		break;

	// *******************************************************
	// NEW OPTIONS
	case ID_TELETEXT:
		qDEBUG("Disabling TELETEXT:START");
		TeleTextAdapterEnabled = 1-TeleTextAdapterEnabled;
		TeleTextInit();
		CheckMenuItem(hMenu, ID_TELETEXT, TeleTextAdapterEnabled ? MF_CHECKED:MF_UNCHECKED);
		qDEBUG("Disabling TELETEXT:END");
		break;

	case ID_HARDDRIVE:
		qDEBUG("Disabling HARDDRIVE:START");
		HardDriveEnabled = 1-HardDriveEnabled;
		qDEBUG("Reseting SCSI");
		SCSIReset();
		qDEBUG("Reseting SASI");
		SASIReset();
		qDEBUG("Updating menus");
		CheckMenuItem(hMenu, ID_HARDDRIVE, HardDriveEnabled ? MF_CHECKED:MF_UNCHECKED);
		qDEBUG("Disabling HARDDRIVE:END");
		break;
	// *******************************************************

//+>
	// Additional BeebEm SDL options:

	case OPT_EMULATECRTGRAPHICS:
		if (cfg_EmulateCrtGraphics == 0)
			cfg_EmulateCrtGraphics = 1;
		else
			cfg_EmulateCrtGraphics = 0;
		break;

	case OPT_EMUALTECRTTELETEXT:
		if (cfg_EmulateCrtTeletext == 0)
			cfg_EmulateCrtTeletext = 1;
		else
			cfg_EmulateCrtTeletext = 0;
		break;

	case OPT_WANTLOWLATENCYSOUND:
		if (cfg_WantLowLatencySound == 0)
			cfg_WantLowLatencySound = 1;
		else
			cfg_WantLowLatencySound = 0;
		break;

	case OPT_SLEEP_OS:
	case OPT_SLEEP_F1:
	case OPT_SLEEP_F2:
	case OPT_SLEEP_F3:
	case OPT_SLEEP_BW:
		cfg_WaitType = MenuId;
		break;


//<+

	}

	SetSound(UNMUTED);
	if (palette_type != prev_palette_type)
	{
		CreateBitmap();
		UpdateMonitorMenu();
	}
}

void BeebWin::SetPBuff(void) {
	CheckMenuItem(m_hMenu,ID_PBUFF,(UsePrimaryBuffer)?MF_CHECKED:MF_UNCHECKED);
}

void BeebWin::SetSoundMenu(void) {
	CheckMenuItem(m_hMenu,IDM_SOUNDONOFF,(SoundEnabled)?MF_CHECKED:MF_UNCHECKED);
	SetPBuff();
}

void BeebWin::Focus(BOOL gotit)
{
	if (gotit)
		m_frozen = FALSE;
	else
		if (m_FreezeWhenInactive)
			m_frozen = TRUE;
}

BOOL BeebWin::IsFrozen(void)
{
	return m_frozen;
}

void SaveEmuUEF(FILE *SUEF) {
	char EmuName[16];
	fput16(0x046C,SUEF);
	fput32(16,SUEF);
	// BeebEm Title Block
	strcpy(EmuName,"BeebEm");
	EmuName[14]=1;
	EmuName[15]=4; // Version, 1.4
	fwrite(EmuName,16,1,SUEF);
	//
	fput16(0x046a,SUEF);
	fput32(16,SUEF);
	// Emulator Specifics
	// Note about this block: It should only be handled by beebem from uefstate.cpp if
	// the UEF has been determined to be from BeebEm (Block 046C)
	fputc(MachineType,SUEF);
	fputc((NativeFDC)?0:1,SUEF);
	fputc(TubeEnabled,SUEF);
	fputc(0,SUEF); // Monitor type, reserved
	fputc(0,SUEF); // Speed Setting, reserved
	fput32(0,SUEF);
	fput32(0,SUEF);
	fput16(0,SUEF);
	fputc(0,SUEF);
}

void LoadEmuUEF(FILE *SUEF, int Version) {
	MachineType=fgetc(SUEF);
	if (Version <= 8 && MachineType == 1)
		MachineType = 3;
	NativeFDC=(fgetc(SUEF)==0)?TRUE:FALSE;
	TubeEnabled=fgetc(SUEF);
	mainWin->ResetBeebSystem(MachineType,TubeEnabled,1);
	mainWin->UpdateModelType();
}

/*****************************************************************************/
// Parse command line parameters

void BeebWin::ParseCommandLine()
{
	char  errstr[200];
	int i;
	int a;
	bool invalid;

	m_CommandLineFileName = NULL;

	pDEBUG("Parse command line");

	i = 1;
	while (i < __argc)
	{
		//printf("%d %d '%s'\n", i, __argc, __argv[i]);
		if (__argv[i][0] == '-' && i+1 >= __argc)
		{
			sprintf(errstr,"Invalid command line parameter:\n  %s", __argv[i]);
			MessageBox(m_hWnd,errstr,WindowTitle,MB_OK|MB_ICONERROR);
		}
		else
		{
			invalid = false;
			if (stricmp(__argv[i], "-Model") == 0)
			{
				a = atoi(__argv[++i]);
				if (a < 0 || a > 3)
					invalid = true;
				else
					MachineType = a;
			}
			else if (stricmp(__argv[i], "-Tube") == 0)
			{
				TubeEnabled = atoi(__argv[++i]);
			}
#ifdef WITH_ECONET
			else if (stricmp(__argv[i], "-EcoStn") == 0)
			{
				a = atoi(__argv[++i]);
				if (a < 1 || a > 254)
					invalid = true;
				else
					EconetStationNumber = a;
			}
			else if (stricmp(__argv[i], "-EcoFF") == 0)
			{
				a = atoi(__argv[++i]);
				if (a < 1)
					invalid = true;
				else
					EconetFlagFillTimeout = a;
			}
#endif
			else if (__argv[i][0] == '-')
			{
				invalid = true;
				++i;
			}
			else
			{
				// Assume its a file name
				m_CommandLineFileName = __argv[i];
			}

			if (invalid)
			{
				sprintf(errstr,"Invalid command line parameter:\n  %s %s", __argv[i-1], __argv[i]);
				MessageBox(m_hWnd,errstr,WindowTitle,MB_OK|MB_ICONERROR);
			}
		}

		++i;
	}
}
	
/*****************************************************************************/
// Handle a file name passed on command line

void BeebWin::HandleCommandLineFile()
{
	HandleFile(m_CommandLineFileName);
}

int BeebWin::HandleFile(char* FileName)
{
	bool ssd = false;
	bool dsd = false;
	bool adfs = false;
	bool cont = false;
	char TmpPath[256];
	//char *FileName = NULL;
	bool uef = false;
	
//## [TODO] This is broken..

	qDEBUG("Load command line file");

	// See if disc image is readable
	if (FileName != NULL)
	{
		pDEBUG(dL"Got filename: '%s'", dR, FileName);

		// Work out which type of files it is
		char *ext = strrchr(FileName, '.');
		if (ext != NULL)
		{
			qDEBUG("Has file extension");

			cont = true;
			if (stricmp(ext+1, "ssd") == 0)
				ssd = true;
			else if (stricmp(ext+1, "dsd") == 0)
				dsd = true;
			else if (stricmp(ext+1, "adl") == 0)
				adfs = true;
			else if (stricmp(ext+1, "adf") == 0)
				adfs = true;
			else if (stricmp(ext+1, "uef") == 0)
				uef = true;
			else
				cont = false;
		}
	}

	if (cont)
	{
		cont = false;

		pDEBUG(dL"Testing file as: '%s'", dR, FileName);

		FILE *fd = fopen(FileName, "rb");
		if (fd != NULL)
		{
			cont = true;
			fclose(fd);

			qDEBUG("Is OK");
		}
		else if (uef)
		{
			// Try getting it from BeebState directory
			strcpy(TmpPath, m_AppPath);
			strcat(TmpPath, "/state/");
			strcat(TmpPath, FileName);
			FILE *fd = fopen(TmpPath, "rb");
			if (fd != NULL)
			{
				cont = true;
				FileName = TmpPath;
				fclose(fd);
			}
		}
		else
		{
			// Try getting it from DiscIms directory
			strcpy(TmpPath, m_AppPath);
			strcat(TmpPath, "/discs/");
			strcat(TmpPath, FileName);

			pDEBUG(dL"Testing file as: '%s'", dR, TmpPath);

			FILE *fd = fopen(TmpPath, "rb");
			if (fd != NULL)
			{
				cont = true;
				FileName = TmpPath;
				fclose(fd);

				pDEBUG("Is OK");
			}
		}
	}

	if (cont)
	{
		if (uef)
		{
			qDEBUG("Load UEF State");
			LoadUEFState(FileName);
			cont = false;
		}
	}

	if (cont)
	{
		if (MachineType!=3)
		{
			if (dsd)
			{
				if (NativeFDC){
					qDEBUG("Load Simple DSD Disc");
					LoadSimpleDSDiscImage(FileName, 0, 80);
				}else{
					qDEBUG("Load 1770 DSD Disc");
					Load1770DiscImage(FileName,0,1,m_hMenu); // 1 = dsd
				}
			}
			if (ssd)
			{
				if (NativeFDC){
					qDEBUG("Load Simple SSD Disc");
					LoadSimpleDiscImage(FileName, 0, 0, 80);
				}else{
					qDEBUG("Load 1770 SSD Disc");
					Load1770DiscImage(FileName,0,0,m_hMenu); // 0 = ssd
				}
			}
			if (adfs)
			{
				if (!NativeFDC){
					qDEBUG("Load Simple ADFS Disc");
					Load1770DiscImage(FileName,0,2,m_hMenu); // 2 = adfs
				}else{
					qDEBUG("Cannot load ADFS with native DFS");
					cont = false;  // cannot load adfs with native DFS
				}
			}
		}
		else if (MachineType==3)
		{
			if (dsd){
				qDEBUG("Load 1770 DSD Disc (for Master)");
				Load1770DiscImage(FileName,0,1,m_hMenu); // 0 = ssd
			}
			if (ssd){
				qDEBUG("Load 1770 SSD Disc (for Master)");
				Load1770DiscImage(FileName,0,0,m_hMenu); // 1 = dsd
			}
			if (adfs){
				qDEBUG("Load 1770 ADFS Disc (for Master)");
				Load1770DiscImage(FileName,0,2,m_hMenu); // 2 = adfs
			}
		}
	}

	if (cont)
	{
		char *SaveName = strrchr(FileName, '/');
		strcpy(mainWin->m_save_name, SaveName);

		//printf("vvv beeb_load_settings\n");
		beeb_load_settings();

		// Do a shift + break
		qDEBUG("Doing a shift + break reset");
		ResetBeebSystem(MachineType,TubeEnabled,0);

//		char *SaveName = strrchr(FileName, '/');
//		strcpy(mainWin->m_save_name, SaveName);

		BeebKeyDown(0, 0); // Shift key
		m_ShiftBooted = true;
	}
}

/****************************************************************************/
// if DLLName is NULL then FDC setting is read from the registry
// else the named DLL is read in
// if save is true then DLL selection is saved in registry
void BeebWin::LoadFDC(char *DLLName, bool save) {

//## Everything below here was disabled.
	char CfgName[20];

	if (MachineType == 0)
		strcpy(CfgName, "FDCDLL");
	else
		sprintf(CfgName, "FDCDLL%d", MachineType);

	NativeFDC=TRUE;

	if (DLLName == NULL) {
		RegRes=SysReg.GetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,CfgName,FDCDLL);
		if (!RegRes) {
			strcpy(FDCDLL,"None");
			if (MachineType == 2) {
				// Default B+ to Acorn FDC
				sprintf(FDCDLL, "Acorn");
			}
			SysReg.SetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,CfgName,FDCDLL);
		}
		DLLName = FDCDLL;
	}

	if (strcmp(DLLName, "None")) {
		printf("BOARD TO LOAD IS: [%s]\n", DLLName);

		if (strncasecmp("Acorn", DLLName,strlen("Acorn"))==0){
			printf("**** LOADING ACORN FDC\n");
			SetAs_AcornFDC();
		}
		if (strncasecmp("Watford", DLLName,strlen("Watford"))==0){
			printf("**** LOADING WATFORD FDC\n");
			SetAs_WatfordFDC();
		}
		if (strncasecmp("Opus", DLLName,strlen("Opus"))==0){
			printf("**** LOADING OPUS FDC\n");
			SetAs_OpusFDC();
		}

		PGetBoardProperties(&ExtBoard);
		EFDCAddr=ExtBoard.FDCAddress;
		EDCAddr=ExtBoard.DCAddress;
		NativeFDC=FALSE; // at last, a working DLL!
		InvertTR00=ExtBoard.TR00_ActiveHigh;
//<-
	}

	pDEBUG(dL"save = %d\n", dR, save);
	pDEBUG(dL"CfgName = %s\n", dR, CfgName);
	pDEBUG(dL"DLLName = %s\n", dR, DLLName);

	if (save)
		SysReg.SetStringValue(HKEY_CURRENT_USER,CFG_REG_KEY,CfgName,DLLName);

	// Set menu options
	if (NativeFDC) {
		CheckMenuItem(m_hMenu,ID_8271,MF_CHECKED);
		CheckMenuItem(m_hMenu,ID_FDC_DLL,MF_UNCHECKED);
	} else {
		CheckMenuItem(m_hMenu,ID_8271,MF_UNCHECKED);
		CheckMenuItem(m_hMenu,ID_FDC_DLL,MF_CHECKED);
	}

	DisplayCycles=7000000;
	if ((NativeFDC) || (MachineType==3))
		DisplayCycles=0;
}

void BeebWin::KillDLLs(void) {
}

void BeebWin::SetDriveControl(unsigned char value) {
	// This takes a value from the mem/io decoder, as written by the cpu, runs it through the 
	// DLL's translator, then sends it on to the 1770 FDC in master 128 form.
	WriteFDCControlReg(PSetDriveControl(value));
}

unsigned char BeebWin::GetDriveControl(void) {
	// Same as above, but in reverse, i.e. reading
	unsigned char temp,temp2;
	temp=ReadFDCControlReg();
	temp2=PGetDriveControl(temp);
	return(temp2);
}

void BeebWin::SetKeymapFile(char* keymapFilename) 
{
	strcpy(m_selected_keymap_file, keymapFilename);
	//m_selected_keymap_file = keymapFilename;
}

/****************************************************************************/
void BeebWin::CaptureVideo()
{
}

/****************************************************************************/
void BeebWin::QuickLoad()
{
	char FileName[_MAX_PATH];
	strcpy(FileName, m_AppPath);
	strcat(FileName, "beebstate\\quicksave.uef");
	LoadUEFState(FileName);
}

void BeebWin::QuickSave()
{
	char FileName1[_MAX_PATH];
	char FileName2[_MAX_PATH];
	int i;

	// Bump old quicksave files down
	for (i = 1; i <= 9; ++i)
	{
		sprintf(FileName1, "%sbeebstate\\quicksave%d.uef", m_AppPath, i);

		if (i == 9)
			sprintf(FileName2, "%sbeebstate\\quicksave.uef", m_AppPath);
		else
			sprintf(FileName2, "%sbeebstate\\quicksave%d.uef", m_AppPath, i+1);

		MoveFileEx(FileName2, FileName1, MOVEFILE_REPLACE_EXISTING);
	}

	SaveUEFState(FileName2);
}



extern "C" 
{
	void beeb_default_settings()
	{
	  /*mainWin->m_snd_enable         = 1;
	  mainWin->m_scr_cpu            = 0;
	  mainWin->m_render_mode        = BEEB_RENDER_NORMAL;*/
	  mainWin->m_skip_cur_frame     = 0;
	  mainWin->m_skip_max_frame     = 0;

	 /* mainWin->m_render_blank_line     =   0;
	  mainWin->m_render_max_blank_line =  50;*/
	}

	int beeb_get_skip_max_frame()
	{
		return mainWin->m_skip_max_frame;
	}

	void beeb_set_skip_max_frame(int value)
	{
		mainWin->m_skip_max_frame = value;
		mainWin->m_skip_cur_frame = 0;
	}

	int beeb_disk_load(char *FileName, int disk_id, int zip_format)
	{
		char *pchPtr;
		char *scan;
		char  SaveName[_MAX_PATH+1];
		char  TmpFileName[_MAX_PATH + 1];
		//dword n;
		int   format;
		int   error;
		
		error = 1;
		//XXX add zip support later
#if 0
		/*if (zip_format) {
			
			zip_info.pchZipFile   = FileName;
			zip_info.pchExtension = ".ssd.dsd.adl.adf.uef.img";
			
			if (!zip_dir(&zip_info)) 
			{
				pchPtr = zip_info.pchFileNames;
				for (n = zip_info.iFiles; n != 0; n--) 
				{
					//XXX
					/*        format = psp_fmgr_getExtId(pchPtr);
					if ((format == FMGR_FORMAT_DISK ) || 
					(format == FMGR_FORMAT_STATE)) break;
					pchPtr += strlen(pchPtr) + 5; // skip offset
					*/
				}
				if (n) {
					strncpy(SaveName,pchPtr,_MAX_PATH);
					scan = strrchr(SaveName,'.');
					if (scan) *scan = '\0';
					beeb_update_save_name(SaveName);
					zip_info.dwOffset = loc_get_dword((byte *)(pchPtr + (strlen(pchPtr)+1)));
					if (!zip_extract(FileName, TmpFileName, zip_info.dwOffset, scan+1)) {
						error = mainWin->HandleFile(TmpFileName, disk_id);
						remove(TmpFileName);
					}
				}
			}
			
		} else 
#endif
		{

			strncpy(SaveName,FileName,_MAX_PATH);
			scan = strrchr(SaveName,'.');
			if (scan) *scan = '\0';
			//beeb_update_save_name(SaveName);
			error = mainWin->HandleFile(FileName /*, disk_id*/);
		}
		
		if (! error ) {
			beeb_kbd_load();
			beeb_load_settings();
		}
		
		return error;
	}

	void beeb_kbd_load(void)
	{
		char        TmpFileName[_MAX_PATH + 1];
		struct stat aStat;
		
		snprintf(TmpFileName, _MAX_PATH, "%s/kbd/%s.kbd", mainWin->GetAppPath(), mainWin->m_save_name );
		if (! stat(TmpFileName, &aStat)) 
		{

			// VVV when virtual keyboard and on-device keymapping possible, re-visit this
			//XXXpsp_kbd_load_mapping(TmpFileName);
		}
	}

	int	beeb_kbd_save(void)
	{
		char TmpFileName[_MAX_PATH + 1];
		snprintf(TmpFileName, _MAX_PATH, "%s/kbd/%s.kbd", mainWin->GetAppPath(), mainWin->m_save_name );
		// VVV when virtual keyboard and on-device keymapping possible, re-visit this
		//XXXreturn( psp_kbd_save_mapping(TmpFileName) );
		return 0;
	}
	

	static int loc_beeb_load_settings(char *chFileName)
	{
		char  Buffer[512];
		char *Scan;
		unsigned int Value;
		FILE* FileDesc;
		
		FileDesc = fopen(chFileName, "r");
		if (FileDesc == (FILE *)0 ) return 0;
		
		while (fgets(Buffer,512, FileDesc) != (char *)0) 
		{
			Scan = strchr(Buffer,'\n');
			if (Scan) *Scan = '\0';
			/* For this #@$% of windows ! */
			Scan = strchr(Buffer,'\r');
			if (Scan) *Scan = '\0';
			if (Buffer[0] == '#') continue;
			
			Scan = strchr(Buffer,'=');
			if (! Scan) continue;
			
			*Scan = '\0';
			Value = atoi(Scan+1);
			
			//if (!strcasecmp(Buffer,"snd_enable")) 
			//	mainWin->m_snd_enable = Value;

			//else
			//if (!strcasecmp(Buffer,"render_mode")) mainWin->m_render_mode = Value;
			if (!strcasecmp(Buffer, "selected_keymap_file"))
			{
				char MapName [250];
				strcpy(MapName, "kbd/");
				strcat(MapName, Scan+1);

				
				//strcpy(kmf, Scan+1);

				if (kbd_load_mapping(MapName));
				{
					//strcpy(m_kmf, Scan+1);
					mainWin->SetKeymapFile(Scan+1);
				}
				//printf("beeb_load_settings for kbd: %s\n", Scan+1);
			}
			else if (!strcasecmp(Buffer,"skip_max_frame")) 
			{
				mainWin->m_skip_max_frame = Value;
			}
		}
		
		fclose(FileDesc);
		
		return 0;
	}

	int beeb_load_settings()
	{
		char  FileName[_MAX_PATH+1];
		int   error;
		
		error = 1;
		
		snprintf(FileName, _MAX_PATH, "%s/set/%s.set", mainWin->GetAppPath(), mainWin->m_save_name);
		error = loc_beeb_load_settings(FileName);
		
		return error;
	}

	static int loc_beeb_save_settings(char *chFileName)
	{
		FILE* FileDesc;
		int   error = 0;
		
		FileDesc = fopen(chFileName, "w");
		if (FileDesc != (FILE *)0 ) 
		{
			
			//fprintf(FileDesc, "sound_mode=%d\n"         , mainWin->m_sound_mode);
			//fprintf(FileDesc, "render_mode=%d\n"        , mainWin->m_render_mode);
			fprintf(FileDesc, "skip_max_frame=%d\n"     , mainWin->m_skip_max_frame);
			fprintf(FileDesc, "selected_keymap_file=%s\n"		, mainWin->m_selected_keymap_file);
			fclose(FileDesc);
			
		} 
		else 
		{
			error = 1;
		}
		
		return error;
	}
	
	int beeb_save_settings()
	{
		char  FileName[_MAX_PATH+1];
		int   error;
		
		error = 1;
		
		snprintf(FileName, _MAX_PATH, "%s/set/%s.set", mainWin->GetAppPath(), mainWin->m_save_name);
		error = loc_beeb_save_settings(FileName);
		
		return error;
	}
	
}
